c	SUBROUTINE GRAB
*
*
*	                     datagrab.for
*
*	datagrab.for takes the data in the file buffer.dat obtained by	
*	dumping data from the guatamala m100 collectring the tilt data
*	and puts it into bob type files.
*
*	Modified to handle up to 32 channels of 5 minute data and 11 channels
*   of one minute data
*
*....................declare the variables
*
$INCLUDE :'GRAB.INC'
	INTEGER*2 IHR,IMIN,ISEC,I100
*
****************************************************************************
*                     let the program begin
****************************************************************************
*
*..................initialize some parameters
	WRITE(6,*) ' STORING DATA'
	CLOSE (4)
	INVAL=-998.0
	PREV_DAY=-1
	PREV_YEAR='-1'
	PREV_INTF='-1'
*..................open the buffer file
	OPEN(UNIT=4,FILE='BUFFER.RAW',STATUS='OLD',MODE='READ',ERR=400)
*..................get the data stream
102	FORMAT(A)	
103	READ(4,102,END=220,ERR=450)STREAM
*				make sure it starts with an @
	IF (STREAM(1:1) .NE. '@') GOTO 103
*................... get the interface number
	INTF=STREAM(2:3)
*			if its not the same interface as before we have
*			to open the map file and get the info
	IF (INTF .NE. PREV_INTF) THEN
		IF (PREV_DAY .NE. -1) THEN
			CALL WRITEM
			CALL CLOSEM
			END IF
		CALL INTF_INFO (*103)
c		set the prev year to -1 so we will open the new files below
		PREV_YEAR='-1'
		END IF
c--------------------------------------------------------------
c		we should have the station, channel, and format info
c		so lets reread the stream
	READ(STREAM,FMT=FRMT,ERR=103)YEAR,DAY,HOUR,MINUTE,
     2	(DS_DATA(I),VAL(I),I=1,CHNLS)
*			is the day ok?
	IF ((DAY .LT. 1) .OR.(DAY .GT. 366)) GOTO 103
*			deal with invalid data points
	DO 115 I=1,CHNLS
		IF (VAL(I) .NE.'>') DS_DATA(I)=INVAL
115		CONTINUE
*----------------------------------------------------------------------
c		check to see if we are in a new day or year and need to write
c		out the data for the current day
	IF (YEAR .NE. PREV_YEAR) THEN
		IF (PREV_YEAR .NE. '-1') THEN
			CALL WRITEM
			CALL CLOSEM
			END IF
		CALL OPENEM
		CALL READEM

		PREV_YEAR=YEAR
		PREV_DAY=DAY
		WRITE (6,FMT=116) DAY
	ELSE IF (DAY .NE. PREV_DAY) THEN
		IF (PREV_DAY .NE. -1) CALL WRITEM
		CALL READEM
		PREV_DAY=DAY
116		FORMAT (' BEGINNING PROCESSING FOR JULIAN DAY ',I3)
		WRITE(6,FMT=116) DAY
		END IF
*.................finally the data gets put into its proper place
c			1440 minutes in a day
	DO 180 I=1,CHNLS
		SPOT=1+(RATE(I)*(HOUR*60+MINUTE))/1440
c			for rates less then or = to 5 minutes we can use data
		IF (RATE(I) .LE. 288) THEN
			DATA(SPOT,I)=DS_DATA(I)
		ELSE
c				otherwise we need to use the one minute arrays (only 11 of them)
			DATA1(SPOT,I)=DS_DATA(I)
			END IF
180		CONTINUE
	CLOSE(3)
*................go back and wait for the next stream of data 
	GOTO 103
*--------------------------------------------------------------------------
*................end of file reached
220	CLOSE(4)
	IF (PREV_DAY .NE. -1) CALL WRITEM
	CALL CLOSEM
	WRITE(6,*) ' '
	CALL GETTIM(IHR,IMIN,ISEC,I100)
221	FORMAT(' READY TO RECEIVE MORE DATA AT ',I2.2,':',I2.2,':',I2.2)
	WRITE(6,221) IHR,IMIN,ISEC
	STOP
c	RETURN
***************************************************************************
*................end of main program
**************************************************************************
*
*
****************************************************************************
*................error messages
****************************************************************************
*
*
390	FORMAT(' ERROR IN OPENING BUFFER.RAW')
400	WRITE(6,390)
	RETURN
450	WRITE(6,*)' ERROR IN READING BUFFER.RAW'
	GOTO 103
	END
*
*****************************************************************************
*...........subprograms follow
****************************************************************************
c			intf_info
c	intf_info opend the file map.dat to get information about the interface
c	it returns with thew station and channel ids, the format statement,
c	and the full pathway to the various directories.
c---------------------------------------------------------------------------
	SUBROUTINE INTF_INFO(*)
c
$INCLUDE :'GRAB.INC'
c---------------------------------------------------------------------------
	DO 100 I=1,32
		STID(I)='NULL'
		CHID(I)='NULL'
100		CONTINUE
c		open up the map file
	OPEN (UNIT=3,FILE='CHNL_MAP.LST',STATUS='OLD',MODE='READ',ERR=400)
*................search for the correct interface
155	FORMAT(A79)
160	READ(3,155,ERR=410,END=410) MAPLINE
	IF (INTF .NE. MAPLINE (11:12)) GOTO 160
161	FORMAT(' FOUND INTERFACE ',A2)
	WRITE(6,161) INTF
*................get the number of stations on that interface (max 32)
	CALL INTGR(CHNLS,MAPLINE(14:15),2,*410)
c		the next line has the format statement
165	FORMAT(A)
	READ(3,165,ERR=410,END=410) FRMT
c		now the base directory. it will be of a format similar to
c		D:\DATA\PICHINCHA\RSAM\stid\chidyr.DAT
c		the lower case letters indicate what will be subed in
	READ(3,165,ERR=410,END=410) FILENAME
c---------------------------------------------------------------------
c	the following lines in the file will have the channel number, its
c	station id, channel id.  if either a station id or channel id=
c	NULL then it will be assumed that nothing exist for that channel
c	even thogh it may be listed
	DO 180 I=1,CHNLS
		READ(3,155,ERR=410,END=410) MAPLINE
		CALL INTGR(VAR1,MAPLINE(14:15),2,*410)
		STID(VAR1)=MAPLINE(2:5)
		CHID(VAR1)=MAPLINE(9:12)
180		CONTINUE
c---------------------------------------------------------------------
c		all done
	PREV_INTF=INTF
	CLOSE(3)
	RETURN
c---------------------------------------------------------------------
400	WRITE(6,*)' CAN NOT LOCATE CHNL_MAP.LST'
	CLOSE(3)
	RETURN(1)
405	FORMAT (' ERROR IN READING MAP.DAT FOR INTERFACE ',A2)
410	WRITE(6,405) INTF	
	CLOSE(3)
	RETURN(1)
	END
c---------------------------------------------------------------------
c*********************************************************************
c		openem
c---------------------------------------------------------------------
c	openem opens all the data files and gets their rates (datapoints/day)
c---------------------------------------------------------------------
	SUBROUTINE OPENEM
c---------------------------------------------------------------------
c
$INCLUDE :'GRAB.INC'
c---------------------------------------------------------------------
c		get some pointers
	PTR1=INDEX(FILENAME,'stid')
	PTR2=INDEX(FILENAME,'chid')
	DO 200 I=1,CHNLS
c			get the file name if necessary
		IF ((STID(I) .EQ. 'NULL').OR.(CHID(I) .EQ. 'NULL')) THEN
			STID(I)='NULL'
			GOTO 200
			END IF
		FILENAME(PTR1:PTR1+3)=STID(I)
		FILENAME(PTR2:PTR2+3)=CHID(I)
		FILENAME(PTR2+4:PTR2+5)=YEAR
c			see if it exists
		INQUIRE(FILE=FILENAME,EXIST=EXISTS)
		IF (.NOT. EXISTS) THEN
110			FORMAT(' NO FILE ',A70)
			WRITE(6,110)FILENAME
			STID(I)='NULL'		
			GOTO 200
			END IF
c				open it and get its rate
		OPEN(UNIT=10+I,FILE=FILENAME,STATUS='OLD',MODE='READ',
     2		RECL=4,FORM='UNFORMATTED',ACCESS='DIRECT',ERR=420)
111		FORMAT(A4)
		READ(10+I,REC=1,ERR=400)C_RECL
		RATE(I)=I_RECL/4
		CLOSE(10+I)
c				reopen it with the correct rate err=400
		OPEN(UNIT=10+I,FILE=FILENAME,STATUS='OLD',
     2		RECL=(4*RATE(I)),FORM='UNFORMATTED',MODE='READWRITE',
     3		ACCESS='DIRECT',ERR=420)
		GOTO 200
c				the error stuff
390			FORMAT(' ERROR READING ',A70)
400			WRITE(6,390)FILENAME

			STID(I)='NULL'
			GOTO 200
410			FORMAT(' ERROR OPENING 'A70)
420			WRITE(6,410) FILENAME
			STID(I)='NULL'		
200		CONTINUE
c------------------------------------------------------------------------
	RETURN
	END
	
c*************************************************************************
c		closem
c-------------------------------------------------------------------------
	SUBROUTINE CLOSEM
c-------------------------------------------------------------------------
$INCLUDE :'GRAB.INC'
	DO 100 I=1,CHNLS
		CLOSE(10+I)
100	CONTINUE
	RETURN
	END
c-------------------------------------------------------------------------
c*************************************************************************
c			readem
c	readem reads the records into the data arrays for each file
c------------------------------------------------------------------------
	SUBROUTINE READEM
$INCLUDE :'GRAB.INC'
c------------------------------------------------------------------------
	DO 300 I=1,CHNLS
		IF (STID(I) .EQ. 'NULL') GOTO 300
c			decide if its to go in the 5 minute arrays or 
c			the one minute
		IF (RATE(I) .LE. 288) THEN
			READ(UNIT=(10+I),REC=DAY+1,ERR=200)
     2			C_DATA(I)(1:RATE(I)*4)
		ELSE
			READ(UNIT=(10+I),REC=DAY+1,ERR=200)
     2			C1_DATA(I)(1:RATE(I)*4)
			END IF
		GOTO 300
190		FORMAT (' ERROR READING ',A4,':',A4,' DAY ',I4)
200		WRITE(6,190)STID(I),CHID(I),DAY
300		CONTINUE
	RETURN
	END
c-------------------------------------------------------------------------
c*************************************************************************
c			writem
c	writem writes the data arrays back to the files
c------------------------------------------------------------------------
	SUBROUTINE WRITEM
$INCLUDE :'GRAB.INC'
c------------------------------------------------------------------------
	DO 300 I=1,CHNLS
		IF (STID(I) .EQ. 'NULL') GOTO 300
c			is it the one minute arrays?
		IF (RATE(I) .LE. 288) THEN
			WRITE(UNIT=(10+I),REC=PREV_DAY+1,ERR=200)
     2			C_DATA(I)(1:RATE(I)*4)
		ELSE
			WRITE(UNIT=(10+I),REC=PREV_DAY+1,ERR=200)
     2			C1_DATA(I)(1:RATE(I)*4)
			END IF
		GOTO 300
190		FORMAT (' ERROR WRITING TO ',A4,':',A4,' DAY ',I4)
200		WRITE(6,190)STID(I),CHID(I),PREV_DAY
300		CONTINUE
	RETURN
	END
c-------------------------------------------------------------------------
*
	SUBROUTINE INTGR(OUTP,STR,NUM,*)
*...............intgr returns the integer value of the number represented by
*...............str. to the integer outp. spaces are changed to 0
	CHARACTER*(*) STR
	INTEGER OUTP,NUM
C	COMMON /GRAB5/OUTP,NUM,STR
	OUTP=0
	DO 100 I=1,NUM
	   IF (STR(I:I) .EQ. ' ') STR(I:I)='0'
	   IF ((STR(I:I).LT.'0') .OR. (STR(I:I).GT.'9')) THEN
	        RETURN(1)
		END IF
	   OUTP=OUTP*10+ICHAR(STR(I:I))-48
100	   CONTINUE
	RETURN
	END
*
*