c
*******************************************************************************
*		newfile
*******************************************************************************
c	newfile takes the users input, makes sure they are valid, and then
c	constructs a data file (filled with the missing point indicator -998.)
c	that can quickly and easily accessed by BOB (i.e. a BOB file). 
*****************************************************************************
c--------		the variables
c--------	the file is a direct access type with each day occupying one
c--------	record and each file holding 1 year of records. the first
c--------	record is a header, however, and it is filled via header.for.
c--------	the data is stored byr reading the data into a real*4 array
c-------	which is equivalenced with a character string. the character 
c-------	string is then read out to the file, so that even a 7 digit
c-------	number takes up only 4 bytes of memory. the maximum number
c------		of data points/day is 1440 (minutes in a day).
	CHARACTER*5760 RECRD
	REAL*4 DATA(1440)
	EQUIVALENCE (RECRD,DATA)
c-------	the file name and some variables to construct it
	CHARACTER*10 FILENME
	CHARACTER*60 FILEDIR
	CHARACTER*3 TYP
	CHARACTER*4 CHID
c-------	and some integer variables to deal with the length of the file
c-------	and leap years
	INTEGER BLKSIZE,RECLNGTH,YR,RATE,DAYS,REC
	EQUIVALENCE (REC,DATA(1))
	CHARACTER*5 ABORT
	LOGICAL EXISTS
c------------------------------------------------------------------------------
c-------	first we construct the file name
90	WRITE (*,*) ' WHAT IS THE COMPLETE PATHWAY TO THIS FILES DIRECTORY
     2'
	WRITE(*,*) ' IF YOU ARE IN THE TARGET DIRECTORY PRESS <ENTER>'
92	FORMAT(A60)
	READ(*,92) FILEDIR
100	FORMAT(1X,'WHAT IS THE MEASUREMENT ID FOR THIS FILE ?',$)
	WRITE(*,100)
110	FORMAT(A4)
	READ(*,110) CHID
	FILENME(1:4)=CHID
c-----------------------------------------------------------------------------
120	FORMAT(1X,'WHAT IS THE YEAR FOR THIS FILE ?',$)
	WRITE(*,120)
	READ(*,*) YR
	YR=MOD(YR,100)
	FILENME(5:5)=CHAR(YR/10+48)
	FILENME(6:6)=CHAR(MOD(YR,10)+48)
	FILENME(7:7)='.'
c------------------------------------------------------------------------------
125	WRITE(*,*)' FILE TYPES ARE OF THE FOLLOWING:'
	WRITE(*,*)'    DAT - THE STANDARD FILE TYPE. '
	WRITE(*,*)'    CLN - FOR CLEANED RAW DATA. THIS IS ONLY USED IF'
	WRITE(*,*)'            YOU EXPECT TO MASSAGE DATA STORED IN A'
	WRITE(*,*)'            DAT FILE AND WANT TO STORE IT.'
c------	the following options are available for BOB but typically just
c			confuse the user.  so we comment them out for now
c	WRITE(*,*)'   3) HUR - HOURLY AVERAGED DATA FILE. ITS DATA RATE IS
c     2 '
c	WRITE(*,*)'            24 POINTS/DAY'
c	WRITE(*,*)'   4) DAY - DAILY AVERAGED DATA FILE. 1 DATA POINT/DAY.
c     2 '
130	FORMAT(1X,'WHAT IS THE FILE TYPE ?',$)
	WRITE(*,130)
140	FORMAT(A3)
	READ(*,140) TYP
	IF ((TYP .NE. 'DAT').AND.(TYP .NE. 'CLN').AND.
     2	(TYP .NE. 'HUR').AND.(TYP .NE. 'DAY')) GOTO 125
	FILENME(8:10)=TYP
c------------------------------------------------------------------------------
145	FORMAT(1X,'FILE DIRECTORY IS ',A60)
	WRITE(*,145) FILEDIR
150	FORMAT(1X,'FILE NAME IS ',A10)
	WRITE(*,150) FILENME
160	FORMAT(1X,'TO REDO TYPE START, TO ABORT TYPE ABORT, TO CONTINUE TY
     2PE <CR>',$)
	WRITE(*,160)
170	FORMAT(A5)
	READ(*,170) ABORT
	IF (ABORT .EQ. 'ABORT') STOP
	IF (ABORT .EQ. 'START') GOTO 90
c----------------------------------------------------------------------------
c------		make sure the file does not already exist
	INQUIRE (FILE=FILENME,EXIST=EXISTS)
	IF (EXISTS) THEN
		WRITE(*,*)' FILE ALREADY EXISTS. OPERATION ABORTED.'
		STOP
		END IF
c-----------------------------------------------------------------------------
c-------	get the data rate (points/day)
	IF ((TYP .EQ. 'DAT') .OR. (TYP .EQ. 'CLN')) THEN
180	FORMAT(1X,'DATA POINTS/DAY (MUST BE AN INTEGRAL DIVISOR OF 1440 MI
     2NUTES IN A DAY) ?',$)
185		WRITE(*,180)
		READ(*,*) RATE
		IF (MOD (1440,RATE) .NE. 0) GOTO 185
	ELSE IF (TYP .EQ. 'HUR') THEN
		RATE=24
	ELSE 
		RATE =1
		END IF
c-----------------------------------------------------------------------------
c-------	get the number of days in a year
	DAYS=365
	IF (MOD(YR,4) .EQ. 0) DAYS=DAYS+1
c-----------------------------------------------------------------------------
c-------the record length = 4*rate (each data point is a real*4 number)
	RECLNGTH=4*RATE
	BLKSIZE=(RECLNGTH+1)*14.0
c---------	we dont want the block or bucket size too big
	IF (BLKSIZE .GT. 10752) BLKSIZE=512*23
c-----------------------------------------------------------------------------
	OPEN(UNIT=2,STATUS='NEW',ACCESS='DIRECT',RECL=RECLNGTH,
     2	FILE=FILENME,FORM='UNFORMATTED')
c--------	the initial record is the header which blanked except for
c			the first 4 bytes which are the reclngth
	DO 200 I=1,RECLNGTH
		RECRD(I:I)=' '
200		CONTINUE
		REC=RECLNGTH
220 	FORMAT(A)
	WRITE(UNIT=2,REC=1,ERR=420) RECRD(1:RECLNGTH)
c--------	fill in data with missing data points (-998.0)
	DO 240 I=1,RATE
		DATA(I)=-998.0
240		CONTINUE
c-------	and store this
	DO 250 I=2,DAYS+1
		WRITE(UNIT=2,REC=I,ERR=420) RECRD(1:RECLNGTH)
250		CONTINUE
c---------------------------------------------------------------------------
c--------		close up and we are all done
	CLOSE(2)
	WRITE(*,*) ' ALL DONE'
	STOP
c-------------		error messages
400 	WRITE (*,*) '  NEWFILE ABORTED'
	STOP
410	WRITE(*,*) ' ERROR IN OPENING THE NEW FILE'
	GOTO 400
420	WRITE(*,*) ' ERROR IN WRITING TO THE NEW FILE'
	GOTO 400
	END
c--------------------------------------------------------------------------