25 '---------------------------------------------------------------------
26 '                store.bas
27 '
28 '  store.bas handles the communication port functions for getting data
29 '  from the peripheral computers.  the data is stored in a file BUFFER.RAW
30 '  until an END of data message is received. the fortran subroutine GRAB
31 '  is then called to process and store the data.  the program then loops
32 '  back to get more data from the COM port.  the program is compiled
33 '  with the communications buffer set to 28000 so that no data overflow
34 '  SHOULD occur and data received while in the GRAB module will be
35 '  available when GRAB is exited.
36 '-----------------------------------------------------------------------
37 '
38 '  declare our subroutines Microsoft Quickbasic 4.0+ allows for linking
39 '  to FORTRAN subroutines
50 DECLARE SUB GRAB () : DECLARE SUB WRRCVD () 
54 '  allow for the increased memory requirements for the FORTRAN variables
55 DIM A2!(5250) : COMMON SHARED /NMALLOC/ A2!()
90 CLOSE 
150 '
210 '*********************************************************************
215 '                  get the data from the radio shack
220 '   we read the data as fast as we can and put it in BUFFER.RAW
225 '
226 PRINT " STARTING AT "+TIME$+" "+DATE$
227 ON ERROR GOTO 1000
228 '   open the com port
230 OPEN "COM1:2400,n,7,1,CS,DS,CD" AS #1
232 '  and the output port. RCVD% is used as a logical to indicate that
234 '  data is being received
235 RCVD%=0 : OPEN "O",#2,"BUFFER.RAW"
240 '  and wait for the data to appear
245 INPUT #1, DATASTREAM$
246 '
247 ' good data strings will begin with an @. if its got one, then store it
248 IF MID$(DATASTREAM$,1,1) = "@" THEN GOTO 300
250 ' if its not a good data string it may be the end of data message to 
251 ' indicate we should process it.
255 IF INSTR(DATASTREAM$,"END") >< 0 THEN GOTO 320
256 ' otherwise go back for more input
260 GOTO 245
265 '---------------------------------------------------------------------
266 '  store the data in the buffer file. if its the first time then
267 '  write a message to the screen.  do it in FORTRAN because Quickbasic
268 '  appears to do direct screen writes (bleeds into other windows)
300 PRINT #2, DATASTREAM$ 
305 IF RCVD%=0 THEN CALL WRRCVD : RCVD%=1
310 GOTO 245
311 '----------------------------------------------------------------------
312 '   go process the data. first close the buffer file
320 CLOSE #2 
321 '   beep and delay to allow the user to know what is going on.  if using
322 '   wordperfect in another window, the user should stop typing until
323 '   GRAB is done (the drive will stop chunking)
325 BEEP : BEEP : FOR I%=1 TO 1500 : NEXT I% 

326 '   the following is bullet-proofing because wordperfect's keyboard
327 '   interrupts cause problems.  I think. when done go back to get
328 '   more data.
340 ON ERR GOTO 500 : CALL GRAB  : ON ERR GOTO 1000 : GOTO 235
350 CALL GRAB : ON ERR GOTO 1000 :GOTO 235
355 '-----------------------------------------------------------------------
500 RESUME 350
1000 RESUME 
