c***************************************************************************
c			tide2bob.for
c--------------------------------------------------------------------------
c		this program takes the data in a sequential qplot type file
c	tide.dat (generated by tide.exe or tide_yr.exe)
c	and inserts the data into a direct access bob type file
c
c	adapted from the generic qplot to bob conversion program
c--------------------------------------------------------------------------
	CHARACTER*70 SEQ_FILE,FORM
	CHARACTER*4 CHID
	CHARACTER*3 CMON
	INTEGER OLD_JUL,JUL,OLD_YR,YEAR,HOUR,MINUTE,RATE,PTR,MONTH,DAY
	REAL*4 DATAPOINT, DATA_IO(1440)
	CHARACTER*5760 CHAROUT
	EQUIVALENCE (DATA_IO,CHAROUT)
c--------------------------------------------------------------------------
c		get the necessary information
80	FORMAT(' THE NAME OF THE SEQUENTIAL FILE ? ',$)
c	WRITE(*,80)
85	FORMAT (A)
c	READ(*,85) SEQ_FILE
	SEQ_FILE='TIDES.DAT'
c	WRITE(*,*)' THE FILE MUST HAVE THE CORRECT ORDERING OF TIME:'
c	WRITE(*,*)' DAY(INT), MONTH(CHAR), YEAR(INT), HOUR(INT), MINUTE(IN
C     2T), DATA(REAL)'
90	FORMAT(' THE FORMAT FOR THE FILE (INCLUDE PARENTHESES) ? ')
C	WRITE(*,90)
c	READ(*,85) FORM
	FORM='(1X,I2,1X,A3,3(1X,I2),2X,F6.3)'
	WRITE(*,*)' THIS PROGRAM ASSUMES THAT THE BOB-STYLE FILE HAS'
	WRITE(*,*)' ALREADY BEEN CREATED WITH NEWFILE.EXE'
95	FORMAT('THE 4 CHARACTER CHANNEL ID FOR THE BOB FILE ? ',$)
	WRITE(*,95)
	READ(*,85) CHID
c---------------------------------------------------------------------------
c		initialize the previous time markers
	OLD_YR=-1
	OLD_JUL=-1
c		open the qplot file and start reading the data
	OPEN(UNIT=2,FILE=SEQ_FILE,STATUS='OLD',MODE='READ',ERR=400)
155	READ(2,FMT=FORM,END=200,ERR=300) DAY,CMON,YEAR,
     2	HOUR,MINUTE,DATAPOINT
	CALL MON_2_IN(CMON,MONTH)
	IF (MONTH .EQ. 0) GOTO 300
	CALL GETJUL(JUL,YEAR,MONTH,DAY)
160	FORMAT(' JULIAN DAY ',I3.3,' PROCESSED')
c--------------------------------------------------------------------------
c			see if we have to open the bob file
	IF (YEAR .NE. OLD_YR) THEN
c				first write out our current day
		IF (OLD_JUL .NE. -1) THEN
			WRITE(*,160) OLD_JUL
			WRITE(UNIT=3,REC=OLD_JUL+1) CHAROUT(1:RATE*4)
			END IF
		IF (OLD_YR .NE. -1) CLOSE(3)
		CALL OPFILE(CHID,YEAR,RATE)
		OLD_YR=YEAR
		READ(UNIT=3,REC=JUL+1) CHAROUT(1:RATE*4)
		OLD_JUL=JUL
c			or just write out the last days data
	ELSE IF (OLD_JUL .NE. JUL) THEN
		IF (OLD_JUL .NE. -1) THEN
			WRITE(*,160) OLD_JUL
			WRITE(UNIT=3,REC=OLD_JUL+1) CHAROUT(1:RATE*4)
			END IF
		OLD_JUL=JUL
		READ(UNIT=3,REC=JUL+1) CHAROUT(1:RATE*4)
		END IF
c------------------------------------------------------------------------
c		that taken care of put the data into our current buffer
	PTR=((HOUR*60+MINUTE)*RATE/1440)+1
	DATA_IO(PTR)=DATAPOINT
c-------------------------------------------------------------------------
c		and go for more
	GOTO 155
c----------------------------------------------------------------------------
c		all done
200	CLOSE (2)
	WRITE(*,160) OLD_JUL
	WRITE(UNIT=3,REC=OLD_JUL+1,ERR=500) CHAROUT(1:RATE*4)
	CLOSE(3)
	WRITE(*,*)' ALL DONE'
	STOP
c-----------------------------------------------------------------------------
c		error in reading the qplot file.  as some files may have
c		some headings or comments, we just note it and continue
	WRITE(*,*) ' FORMAT ERROR IN READING QPLOT FILE'
300	GOTO 155
c----------------------------------------------------------------------------
c		nasty error or no qplot file. return to fill arrays with
c		normal direct access procedures
400	WRITE(*,*) ' ERROR IN QPLOT FILE SET-UP'
450	CLOSE(2)
	STOP
500	WRITE(*,*)' ERROR IN ACCESSING TARGET FILE'
	STOP	
	END
c----------------------------------------------------------------------------
*****************************************************************************
*				getjul
*****************************************************************************
c		getjul returns the julian day for the arguements month, day, year
c---------------------------------------------------------------------------
	SUBROUTINE GETJUL(JL,YR,MON,DAY)
	INTEGER JL,MON,YR,DAY,N,N1
	JL=0
	DO 100 I=1,(MON-1)
	  JL=JL+31
	  IF (I.EQ.2) THEN
	    JL=JL-3
	    IF ((MOD(YR,4)) .EQ. 0) JL=JL+1
	  END IF
	  IF (I .EQ. 4) JL=JL-1
	  IF (I .EQ. 6) JL=JL-1
	  IF (I .EQ. 9) JL=JL-1
	  IF (I .EQ. 11) JL=JL-1
100	  CONTINUE
	JL=JL+DAY
	RETURN
	END
 
*******************************************************************************
*			opfile
c-----------------------------------------------------------------------------
c-----opfile gets a filename as per its arguments. it then sees if the file
c-----exists, what the data rate is. if all is ok, the
c-----file is opened as unit=3.
c------------------------------------------------------------------------------
	SUBROUTINE OPFILE(CHID,YEAR,RATE)
c-----------------------------------------------------------------------------
	INTEGER YEAR,RATE
	CHARACTER*4 CHID,C_REC
	INTEGER REC
	EQUIVALENCE (REC,C_REC)
	LOGICAL EXST
	CHARACTER*10 NAME
c-----------------------------------------------------------------------------
c		program begins
******************************************************************************
c---------------construct the filename
	NAME(1:4)=CHID
	YEAR=MOD(YEAR,100)
	CALL ICONVERT(YEAR,NAME(5:6),2)
	NAME(7:10)='.DAT'
	EXST=.FALSE.
c		check for the files existence
	INQUIRE(FILE=NAME,EXIST=EXST)
	IF (.NOT.EXST) THEN
		WRITE(*,*) 'TARGET FILE DOES NOT EXIST. USE NEWFILE.EXE TO CREA
     2TE IT'
		STOP
		END IF
c		see what its data rate is (record length/4)
	OPEN(UNIT=3,FILE=NAME,STATUS='OLD',MODE='READ',RECL=4,
     2	FORM='UNFORMATTED',ACCESS='DIRECT')
	READ(UNIT=3,REC=1) C_REC
	CLOSE(3)
	RATE=REC/4
c-------------------------------------------------------------------------
c		open the file for reading and writing
	OPEN(UNIT=3,STATUS='OLD',ACCESS='DIRECT',
     2		FILE=NAME,FORM='UNFORMATTED',MODE='READWRITE',
     3		RECL=(RATE*4))
c--------------------------------------------------------------------------
	RETURN
c--------------------------------------------------------------------------
175	WRITE(*,*) ' ERROR IN ACCESSING FILE ',NAME
	STOP
	END
c**************************************************************************
	SUBROUTINE ICONVERT(N,STR,LNG)
c	      **iconvert converts an integer n composed of lng digits
c	      **into a string str of length lng
	INTEGER LNG,N,N1,N2,PTR
	CHARACTER*(*) STR
	N1=N
	PTR=1
	DO 200 I=(LNG-1),0,-1
		N2=INT(N1/10**I)
		STR(PTR:PTR)=CHAR(N2+48)
		N1=N1-(N2*10**I)
		PTR=PTR+1
200		CONTINUE
	RETURN
	END
c--------------------------------------------------------------------------
c***************************************************************
c			mon_2_int
c--------------------------------------------------------------
c		returns the corresponding integer value for the
c	3 character value for the month. for the integer inputs for
c	the month you must read it A2, not A3.
c--------------------------------------------------------------
	SUBROUTINE MON_2_INT (MONTH,IMON)
c--------------------------------------------------------------
	CHARACTER*3 MONTH
	INTEGER IMON
	CHARACTER*3 UP_MON(12),LO_MON(12),MX_MON(12)
	CHARACTER*3 IN_MON(12),LZ_MON(12)
c------------------------------------------------------------
c		the search begins
c------------------------------------------------------------
	DATA UP_MON /'JAN','FEB','MAR','APR','MAY','JUN','JUL',
     2	'AUG','SEP','OCT','NOV','DEC'/
	DATA LO_MON /'jan','feb','mar','apr','may','jun','jul',
     2	'aug','sep','oct','nov','dec'/
	DATA MX_MON /'Jan','Feb','Mar','Apr','May','Jun','Jul',
     2	'Aug','Sep','Oct','Nov','Dec'/
	DATA IN_MON /' 1 ',' 2 ',' 3 ',' 4 ',' 5 ',' 6 ',' 7 ',
     2	' 8 ',' 9 ','10 ','11 ','12 '/
	DATA LZ_MON /'01 ','02 ','03 ','04 ','05 ','06 ','07 ',
     2	'08 ','09 ','10 ','11 ','12 '/
c--------------------------------------------------------------
	IMON=0
	DO 100 I=1,12
		IF (MONTH .EQ. UP_MON(I)) THEN
			IMON=I
			GOTO 110
		ELSE IF (MONTH .EQ. LO_MON(I)) THEN
			IMON=(I)
			GOTO 110
		ELSE IF (MONTH .EQ. MX_MON(I)) THEN
			IMON=(I)
			GOTO 110
		ELSE IF (MONTH .EQ. IN_MON(I)) THEN
			IMON=I
			GOTO 110
		ELSE IF (MONTH .EQ. LZ_MON(I)) THEN
			IMON=I
			GOTO 110
			END IF
100		CONTINUE
110	RETURN
	END
c----------------------------------------------------------------
