c	TIDES.FOR  --  A program to calculate earth tides for a year.

	character date*6, time*4, volcano*35, name*35
	integer   dated, datem, datey, day, elev, hour, j, k, latd
	integer   latm, longd, longm, min, month, timeh, timem, year
	real      grav, gt, lat_d, lat_m, long_d, long_m, selev, slatd
	real      slatm, slongd, slongm, yval
	INTEGER LOC_OFF,LOC_HR	
	CHARACTER*3 CMON

	write(*,*)
	write(*,*)
	write(*,*) '* Earth Tides Calculator *'
	write(*,*)
	volcano=' '
 1	write(*,800) 'What volcano? '
	read(*,805) volcano
 805	format(a)
	do 2 j=34,2,-1
		if(volcano(j:j) .ne. ' ') goto 3
 2	continue
	goto 9

 3	do 8 i=1,j
		if(ichar(volcano(i:i)) .lt. 123 .and. ichar(volcano(i:i)) .gt.
     2	96) then
			volcano(i:i)=char(ichar(volcano(i:i))-32)
			endif
 8	continue

	open(2,file='latlong.dat',status='old')
 4	read(2,806,end=6) name,lat_d,long_d,elev
 806	format(a35,f7.3,1x,f8.3,1x,i4)
	do 5 k=1,35-j
		if(name(k:k+j-1) .eq. volcano(1:j)) goto 7
 5	continue
	goto 4
 6	rewind 2
	goto 1

 7	close(2,status='keep')
	WRITE(*,*)NAME,LAT_D,LONG_D,ELEV
	lat_m=100*(lat_d-float(int(lat_d)))
	lat_d=float(int(lat_d))
	long_m=100*(long_d-float(int(long_d)))
	long_d=float(int(long_d))
	selev=float(elev)
	goto 40

 9	write(*,*) 'Conventions:'
	write(*,*)
	write(*,*) 'Degrees west of Greenwich 0<=x<=180'
	write(*,*) '        east of Greenwich -180<=x<=0'
	write(*,*) 'Degress north of equator 0<=x<=90'
	write(*,*) '        south of equator -90<=x<=0'
	write(*,*)
	write(*,*) 'Minutes are not decimal.'
	write(*,*)

 10	write(*,*)
	write(*,800) 'Longitude (degrees, minutes - i4,i2 format)?    '
 800	format(1x,a,$)
	read(*,801,err=10) longd,longm
 801	format(i4,1x,i2)
	if(longd .lt. -180 .or. longd .gt. 180) goto 10
	if(longm .lt. 0 .or. longm .ge. 60) goto 10
	long_m=float(longm*100/60)
	long_d=float(longd)

 20	write(*,800) 'Latitude (degrees, minutes - i3,i2 format)?      '
	read(*,802,err=20) latd,latm
 802	format(i3,1x,i2)
	if(latd .lt. -90 .or. latd .gt. 90) goto 20
	if(latm .lt. 0 .or. latm .ge. 60) goto 20
	lat_m=float(latm*100/60)
	lat_d=float(latd)

 30	write(*,800) 'Elevation above sea level (meters - i6 format)?  '
	read(*,803,err=30) elev
 803	format(i6)
	selev=float(elev)

 40	write(*,800) 'Enter the year (yy -- ex. 81) >      '
 	DATE(1:2)='01'
	read(*,804,err=40) date(3:4)
 804	format(a2)
	month=((ichar(date(1:1))-48)*10)+(ichar(date(2:2))-48)
	if(month .lt. 1 .or. month .gt. 12) goto 40
	year=((ichar(date(3:3))-48)*10)+(ichar(date(4:4))-48)
	if(year .lt. 0 .or. year .gt. 99) goto 40

c----------------------------------------------------------------
c		get offset for local time
	WRITE (*,*) ' ENTER HOURS OF OFFSET BETWEEN LOCAL TIME AND GMT'
	WRITE(*,*) ' THIS IS A NEGATIVE NUMBER IN THE WESTERN HEMISPHERE'
	READ(*,*) LOC_OFF
	write(*,*)
	write(*,800) 'Working...'
	OPEN(1,FILE='TIDES.DAT',STATUS='NEW')
	DO 51 MONTH=1,12
	leap=int(year/10)
	leap2=year-leap*10
	CALL MON_2_INT(CMON,MONTH)
	do 50 day=1,31
		if (day .eq. 31 .and. (month .eq. 4 .or. month .eq. 6 .or.
     2	month .eq. 9 .or. month .eq. 11)) goto 51
		if (day .gt. 29 .and. month .eq. 2) goto 51
		if (day .eq. 29 .and. month .eq. 2) then
			if (leap .eq. 0 .or. leap .eq. 2 .or. leap .eq. 4
     2		.or. leap .eq. 6 .or. leap .eq. 8) then
				if (leap2 .ne. 0 .and. leap2 .ne. 4 .and.
     2			leap2 .ne. 8) goto 51
				goto 45
				endif
			if (leap2 .ne. 2 .and. leap2 .ne. 6) goto 51
			endif

 45	do 47 hour=0,23
C			do 46 min=0,50,10
				LOC_HR=hour-LOC_OFF
 				call calc(lat_d,lat_m,long_d,long_m,selev,
     2			month,day,year,LOC_HR,min,gt)
				write(1,90) day,CMON,year,hour,min,gt
 90				format(1x,i2.2,'-',a3,'-',i2.2,1x,i2.2,':',i2.2,2x,
     2				f6.3)
C		46			continue
 47		continue

 50    continue
 51    CONTINUE
 60	close(1,status='keep')
	stop ' '
	end


	SUBROUTINE CALC(slatd,slatm,slongd,slongm,selev,datem,dated,datey,
     1	timeh,timem,gt)

c	The origin of this routine is the Menlo Park VAX (6/30/83)

c	slatd,slatm,slongd,slongm -- REAL minutes are decimal
c	selev                     -- REAL elevation in meters
c	datem,dated,datey         -- INTEGER dates (month, day, year 19__)
c	timeh,timem               -- INTEGER times, GMT (hour, minute)
c	gt(timem)                 -- REAL micro gals

	dimension        daypm(12)
	double precision almoon, alpha, alsun, an, anc1, cdegtr, arg6,
     2	arg7
	double precision arg9, arg10, chi, chi1, cmintr, csectr, dcos, 
     2	dsin
	double precision h, hc1, hminp1, p, p1, pc1, pi2, s, s2hp, sc1, 
     2	sigma
	double precision sminh, sminh2, sminp, sminp2, stor, t, xi
	integer          dated, datem, datey, timeh, timem

	cdegtr=1.7453292519943d-2
	cmintr=2.90888208666d-4
	csectr=4.848136811d-6
	c=3.84402e10
	c1=1.495e13
	e=.05490
	ratio=.074804
	omega=23.452*cdegtr
	smalla=6.37827e8
	amu=6.670e-8
	ammoon=7.3537e25
	amsun=1.993e33
	pi2=6.2831853072d0
	sc1=1108411.2d0
	pc1=392515.94d0
	hc1=129602768.13d0
	anc1=482912.63d0
	e11=1.675104e-2
	e12=4.180e-5
	e13=1.26e-7
 5	days2=0.
	alambd=slatd*cdegtr+slatm*cmintr
	along=slongd+slongm/60.
	elev=selev*100.
	month=datem
	iday=dated
	iyear=datey
	ihour=timeh
	minute=timem

c	Calculate T (number of Julian centuries)

	data daypm/31.,28.,31.,30.,31.,30.,31.,31.,30.,31.,30.,31./

	do 100 i=1,12
		js=month-i
		if(js .eq. 0) goto 150
 100	days2=days2+daypm(i)

 150	days3=iday-1
	days4=ihour/24.
	days5=minute/(24.*60.)
	days1=iyear*365.
	nyear=iyear/4
	sj=iyear/4.-nyear
	if(sj .gt. 0) goto 200
	if(month-2) 300,300,200
 200	days6=nyear
	go to 350
 300	days6=nyear-1.

 350	stor=days1+days2+days3+days4+days5+days6+.5
	t=stor/36525.

	s=270.*cdegtr+26.*cmintr+14.72*csectr+(1336.*pi2+sc1*csectr)*t
     1	+9.09*csectr*(t**2)+.0068*csectr*(t**3)

	p=334.*cdegtr+19.*cmintr+40.87*csectr+(11.*pi2+pc1*csectr)*t
     1	-37.24*csectr*(t**2)-.045*csectr*(t**3)

	h=279.*cdegtr+41.*cmintr+48.04*csectr+hc1*csectr*t+1.089*csectr
     1	*(t**2)

	an=259.*cdegtr+10.*cmintr+57.12*csectr-(5.*pi2+anc1*csectr)*t
     1	+7.58*csectr*(t**2)+.008*csectr*(t**3)

	p1=281.*cdegtr+13.*cmintr+15.*csectr+6189.03*csectr*t+1.63*csectr
     1	*(t**2)+.012*csectr*(t**3)

	e1=e11-e12*t-e13*(t**2)
	arg1=1./(1.+.006738*(sin(alambd)**2))
	capc=sqrt(arg1)
	radius=capc*smalla+elev
	aprime=1./(c*(1.-e**2))
	aprim1=1./(c1*(1.-e1**2))
	sminp=s-p
	s2hp=s-2*h+p
	sminh=s-h
	hminp1=h-p1
	sminp2=2.*sminp
	sminh2=2.*sminh
	distem=1./c+aprime*e*dcos(sminp)+aprime*(e**2)*dcos(sminp2)
     1	+15*aprime*ratio*e*dcos(s2hp)/8.+aprime*(ratio**2)*dcos(sminh2)

	distes=1./c1+aprim1*e1*dcos(hminp1)
	tzero=ihour+minute/60.
	smallt=(15.*(tzero-12.)-along)*cdegtr
	chi1=smallt+h
	alsun=h+2.*e1*dsin(hminp1)
	arg2=5.145*cdegtr
	arg3=cos(omega)*cos(arg2)-sin(omega)*sin(arg2)*dcos(an)
	ai=acos(arg3)
	arg4=sin(arg2)*dsin(an)/sin(ai)
	anu=asin(arg4)
	chi=smallt+h-anu
	salpha=sin(omega)*dsin(an)/sin(ai)
	calpha=dcos(an)*cos(anu)+dsin(an)*sin(anu)*cos(omega)
	calph1=1+calpha
	alpha=2*atan2(salpha,calph1)
	xi=an-alpha
	sigma=s-xi

	almoon=sigma+2.*e*dsin(sminp)+5.*(e**2)*dsin(sminp2)/4.
     1	+15.*ratio*e*dsin(s2hp)/4.+11.*(ratio**2)*dsin(sminh2)/8.

	arg5=(omega/2.)
	arg6=alsun-chi1
	arg7=alsun+chi1

	cphi=sin(alambd)*sin(omega)*dsin(alsun)+cos(alambd)*((cos(arg5)**2
     1	*dcos(arg6)+(sin(arg5)**2)*dcos(arg7)))

	arg8=(ai/2.)
	arg9=almoon-chi
	arg10=almoon+chi

	ctheta=sin(alambd)*sin(ai)*dsin(almoon)+cos(alambd)*((cos(arg8)**2
     1	)*dcos(arg9)+(sin(arg8)**2)*dcos(arg10))

	qr=1000
 	distem=distem*qr
	distes=distes*qr

	gm=amu*ammoon*radius*(3.*(ctheta**2)-1.)*(distem**3)/(qr**3)
     1	+3*(amu*ammoon*(radius**2)*(5.*(ctheta**3)-3.*ctheta))*
     2	(distem**4)/(2*qr**4)

	gm=gm*1000.
	gs=amu*amsun*radius*(3.*(cphi**2)-1)*(distes**3)*1000./(qr**3)
	gzero=gm+gs

	gt=gzero*1.16

	return
	end
c***************************************************************
c			mon_2_int
c--------------------------------------------------------------
c		returns the corresponding 3 character value for the
c	integer for the month.
c--------------------------------------------------------------
	SUBROUTINE MON_2_INT (MONTH,IMON)
c--------------------------------------------------------------
	CHARACTER*3 MONTH
	INTEGER IMON
	CHARACTER*3 UP_MON(12)
c------------------------------------------------------------
c		the search begins
c------------------------------------------------------------
	DATA UP_MON /'JAN','FEB','MAR','APR','MAY','JUN','JUL',
     2	'AUG','SEP','OCT','NOV','DEC'/
c--------------------------------------------------------------
	IF ((IMON.LT. 0).OR.(IMON .GT.12)) THEN
		MONTH='xxx'
	ELSE
		MONTH=UP_MON(IMON)
		END IF
	RETURN
	END
c----------------------------------------------------------------