c--------------------------------------------------------------------------
c		this program takes the data in a sequential file with the date
c		in day-month year style (i.e. 24/DEC/1988)
c		and inserts the data into a direct access bob type file
c--------------------------------------------------------------------------
	CHARACTER*70 SEQ_FILE,FORM
$INCLUDE : 'EUR_2BOB.INC'
c--------------------------------------------------------------------------
c		get the necessary information
	WRITE(*,*)' THIS PROGRAM TAKES TIME SERIES DATA FROM A SEQUENTIAL'
	WRITE(*,*)' FILE WITH A EUROPEAN STYLE DATE (I.E. 12-JUL-88) AND'
	WRITE(*,*)' PLACES THE DATA IN A BOB DATA FILE.'
	WRITE(*,*)' ** THE BOB DATA FILES MUST ALREADY EXIST (USE'
	WRITE(*,*)'    NEWFILE) AND BE IN YOUR CURRENT DIRECTORY'
80	FORMAT(' THE NAME OF THE EUROPEAN DATE SEQUENTIAL FILE ? ',$)
	WRITE(*,80)
85	FORMAT (A)
	READ(*,85) SEQ_FILE
	WRITE(*,*) ' '
	WRITE(*,*)' THE FILE MUST HAVE THE CORRECT ORDERING OF TIME:'
	WRITE(*,*)' DAY(INT), MONTH(CHAR), YEAR(INT), HOUR(INT), MINUTE(IN
     2T), DATA(REAL)'
	WRITE(*,*)' THE FOLLOWING IS A TYPICAL DATA LINE AND BELOW ITS FOR
     2MAT'
	WRITE(*,*) ' '
	WRITE(*,*)'03 MAR 85 11:47  -456.74   844.34  344'
	WRITE(*,*)'THE FORMAT IS: (I2,1X,A3,3(1X,I2),2(2X,F7.2),2X,F3.0)' 
	WRITE(*,*)' '
90	FORMAT(' THE FORMAT FOR YOUR FILE (INCLUDE PARENTHESES) ? ')
	WRITE(*,90)
	READ(*,85) FORM
92	FORMAT(' NUMBER OF COLUMNS OF DATA YOU WANT STORED: ',$)
	WRITE(*,92)
	READ(*,'(I2)') COLUMNS
95	FORMAT(' THE 4 CHARACTER CHANNEL ID FOR COLUMN ',I2.0,' : ',$)
96	FORMAT(A4)
	DO 98 I=1,COLUMNS
		WRITE(*,95) I
		READ(*,96) CHID(I)
98		CONTINUE
c---------------------------------------------------------------------------
c		initialize the previous time markers
	PREV_YEAR='-1'
	PREV_JUL=-1
c		open the eur file and start reading the data
	OPEN(UNIT=2,FILE=SEQ_FILE,STATUS='OLD',MODE='READ',ERR=400)
155	READ(2,FMT=FORM,END=200,ERR=300) DAY,CMON,IYEAR,
     2	HOUR,MINUTE,(DS_DATA(I),I=1,COLUMNS)
	IYEAR=MOD(IYEAR,100)
	CALL ICONVERT(IYEAR,YEAR,2) 
	CALL MON_2_IN(CMON,MONTH)
	IF (MONTH .EQ. 0) GOTO 300
	CALL GETJUL(JUL,IYEAR,MONTH,DAY)
160	FORMAT(' PROCESSING JULIAN DAY ',I3.3)
c--------------------------------------------------------------------------
c			see if we have to open the bob file
	IF (YEAR .NE. PREV_YEAR) THEN
c				first write out our current day if we must
		IF (PREV_YEAR .NE. '-1') THEN
			CALL WRITEM
			CALL CLOSEM
			END IF
c  				get the stuff from the new year
		CALL OPENEM
		CALL READEM
		PREV_YEAR=YEAR
		PREV_JUL=JUL
		WRITE(*,160) JUL
c			 just write out the last days data ?
	ELSE IF (JUL .NE. PREV_JUL) THEN
		IF (PREV_JUL .NE. -1) CALL WRITEM
		CALL READEM
		PREV_JUL=JUL
		WRITE(*,160) JUL
		END IF
c------------------------------------------------------------------------
c			finally put the data into the proper place in the array
c				remember 1440 minutes in a day
	DO 180 I=1,COLUMNS
		SPOT=1+(RATE(I)*(HOUR*60+MINUTE))/1440
c				for rates <= 5 minutes use DATA
		IF (RATE(I) .LE. 288) THEN
			DATA(SPOT,I)=DS_DATA(I)
c				else use the one minute arrays (only 11 of them)
		ELSE
			DATA1(SPOT,I)=DS_DATA(I)
			END IF
180	CONTINUE
c			back for more
	GOTO 155
c----------------------------------------------------------------------------
c		all done
200	CLOSE (2)
	IF (PREV_JUL .NE. -1) CALL WRITEM
	CALL CLOSEM	
	WRITE(*,*)' ALL DONE'
	STOP
c-----------------------------------------------------------------------------
c		error in reading the eur file.  as some files may have
c		some headings or comments, we just note it and continue
	WRITE(*,*) ' FORMAT ERROR IN READING EUR FILE'
300	GOTO 155
c----------------------------------------------------------------------------
c		nasty error or no eur file. return to fill arrays with
c		normal direct access procedures
400	WRITE(*,*) ' ERROR IN EUR FILE SET-UP'
450	CLOSE(2)
	STOP
	END
c----------------------------------------------------------------------------
*****************************************************************************
*				getjul
*****************************************************************************
c		getjul returns the julian day for the arguements month, day, year
c---------------------------------------------------------------------------
	SUBROUTINE GETJUL(JL,YR,MON,DAY)
	INTEGER JL,MON,YR,DAY,N,N1
	JL=0
	DO 100 I=1,(MON-1)
	  JL=JL+31
	  IF (I.EQ.2) THEN
	    JL=JL-3
	    IF ((MOD(YR,4)) .EQ. 0) JL=JL+1
	  END IF
	  IF (I .EQ. 4) JL=JL-1
	  IF (I .EQ. 6) JL=JL-1
	  IF (I .EQ. 9) JL=JL-1
	  IF (I .EQ. 11) JL=JL-1
100	  CONTINUE
	JL=JL+DAY
	RETURN
	END
 
c**************************************************************************
	SUBROUTINE ICONVERT(N,STR,LNG)
c	      **iconvert converts an integer n composed of lng digits
c	      **into a string str of length lng
	INTEGER LNG,N,N1,N2,PTR
	CHARACTER*(*) STR
	N1=N
	PTR=1
	DO 200 I=(LNG-1),0,-1
		N2=INT(N1/10**I)
		STR(PTR:PTR)=CHAR(N2+48)
		N1=N1-(N2*10**I)
		PTR=PTR+1
200		CONTINUE
	RETURN
	END
c--------------------------------------------------------------------------
c***************************************************************
c			mon_2_int
c--------------------------------------------------------------
c		returns the corresponding integer value for the
c	3 character value for the month. for the integer inputs for
c	the month you must read it A2, not A3.
c--------------------------------------------------------------
	SUBROUTINE MON_2_INT (MONTH,IMON)
c--------------------------------------------------------------
	CHARACTER*3 MONTH
	INTEGER IMON
	CHARACTER*3 UP_MON(12),LO_MON(12),MX_MON(12)
	CHARACTER*3 IN_MON(12),LZ_MON(12)
c------------------------------------------------------------
c		the search begins
c------------------------------------------------------------
	DATA UP_MON /'JAN','FEB','MAR','APR','MAY','JUN','JUL',
     2	'AUG','SEP','OCT','NOV','DEC'/
	DATA LO_MON /'jan','feb','mar','apr','may','jun','jul',
     2	'aug','sep','oct','nov','dec'/
	DATA MX_MON /'Jan','Feb','Mar','Apr','May','Jun','Jul',
     2	'Aug','Sep','Oct','Nov','Dec'/
	DATA IN_MON /' 1 ',' 2 ',' 3 ',' 4 ',' 5 ',' 6 ',' 7 ',
     2	' 8 ',' 9 ','10 ','11 ','12 '/
	DATA LZ_MON /'01 ','02 ','03 ','04 ','05 ','06 ','07 ',
     2	'08 ','09 ','10 ','11 ','12 '/
c--------------------------------------------------------------
	IMON=0
	DO 100 I=1,12
		IF (MONTH .EQ. UP_MON(I)) THEN
			IMON=I
			GOTO 110
		ELSE IF (MONTH .EQ. LO_MON(I)) THEN
			IMON=(I)
			GOTO 110
		ELSE IF (MONTH .EQ. MX_MON(I)) THEN
			IMON=(I)
			GOTO 110
		ELSE IF (MONTH .EQ. IN_MON(I)) THEN
			IMON=I
			GOTO 110
		ELSE IF (MONTH .EQ. LZ_MON(I)) THEN
			IMON=I
			GOTO 110
			END IF
100		CONTINUE
110	RETURN
	END
c----------------------------------------------------------------
c*********************************************************************
c		openem
c---------------------------------------------------------------------
c	openem opens all the data files and gets their rates (datapoints/day)
c---------------------------------------------------------------------
	SUBROUTINE OPENEM
c---------------------------------------------------------------------
c
	CHARACTER*10 FILENAME
$INCLUDE : 'EUR_2BOB.INC'
c---------------------------------------------------------------------
c		file name is of the format chidyr.dat
	FILENAME='chidyr.DAT'
	DO 200 I=1,COLUMNS
c			get the file name 
		FILENAME(1:4)=CHID(I)
		FILENAME(5:6)=YEAR
c			see if it exists
		INQUIRE(FILE=FILENAME,EXIST=EXISTS(I))
		IF (.NOT. EXISTS(I)) THEN
110			FORMAT(' NO FILE ',A70)
			WRITE(6,110)FILENAME	
			RATE(I)=24
			GOTO 200
			END IF
c				open it and get its rate
		OPEN(UNIT=10+I,FILE=FILENAME,STATUS='OLD',MODE='READ',
     2		RECL=4,FORM='UNFORMATTED',ACCESS='DIRECT',ERR=420)
111		FORMAT(A4)
		READ(10+I,REC=1,ERR=400)C_RECL
		RATE(I)=I_RECL/4
		CLOSE(10+I)
c				reopen it with the correct rate err=400
		OPEN(UNIT=10+I,FILE=FILENAME,STATUS='OLD',
     2		RECL=(4*RATE(I)),FORM='UNFORMATTED',MODE='READWRITE',
     3		ACCESS='DIRECT',ERR=420)
		GOTO 200
c				the error stuff
390			FORMAT(' ERROR READING ',A70)
400			WRITE(6,390)FILENAME

			EXISTS(I)=.FALSE.
			GOTO 200
410			FORMAT(' ERROR OPENING 'A70)
420			WRITE(6,410) FILENAME
			EXISTS(I)=.FALSE.		
200		CONTINUE
c------------------------------------------------------------------------
	RETURN
	END
	
c*************************************************************************
c		closem
c-------------------------------------------------------------------------
	SUBROUTINE CLOSEM
c-------------------------------------------------------------------------
$INCLUDE : 'EUR_2BOB.INC'
	DO 100 I=1,COLUMNS
		CLOSE(10+I)
100	CONTINUE
	RETURN
	END
c-------------------------------------------------------------------------
c*************************************************************************
c			readem
c	readem reads the records into the data arrays for each file
c------------------------------------------------------------------------
	SUBROUTINE READEM
$INCLUDE : 'EUR_2BOB.INC'
c------------------------------------------------------------------------
	DO 300 I=1,COLUMNS
		IF (.NOT.(EXISTS(I))) GOTO 300
c			decide if its to go in the 5 minute arrays or 
c			the one minute
		IF (RATE(I) .LE. 288) THEN
			READ(UNIT=(10+I),REC=JUL+1,ERR=200)
     2			C_DATA(I)(1:RATE(I)*4)
		ELSE
			READ(UNIT=(10+I),REC=JUL+1,ERR=200)
     2			C1_DATA(I)(1:RATE(I)*4)
			END IF
		GOTO 300
190		FORMAT (' ERROR READING ',A4,' DAY ',I4)
200		WRITE(6,190)CHID(I),JUL
300		CONTINUE
	RETURN
	END
c-------------------------------------------------------------------------
c*************************************************************************
c			writem
c	writem writes the data arrays back to the files
c------------------------------------------------------------------------
	SUBROUTINE WRITEM
$INCLUDE : 'EUR_2BOB.INC'
c------------------------------------------------------------------------
	DO 300 I=1,COLUMNS
		IF (.NOT.(EXISTS(I))) GOTO 300
c			is it the one minute arrays?
		IF (RATE(I) .LE. 288) THEN
			WRITE(UNIT=(10+I),REC=PREV_JUL+1,ERR=200)
     2			C_DATA(I)(1:RATE(I)*4)
		ELSE
			WRITE(UNIT=(10+I),REC=PREV_JUL+1,ERR=200)
     2			C1_DATA(I)(1:RATE(I)*4)
			END IF
		GOTO 300
190		FORMAT (' ERROR WRITING TO ',A4,' DAY ',I4)
200		WRITE(6,190)CHID(I),PREV_DAY
300		CONTINUE
	RETURN
	END
c-------------------------------------------------------------------------
*
	SUBROUTINE INTGR(OUTP,STR,NUM,*)
*...............intgr returns the integer value of the number represented by
*...............str. to the integer outp. spaces are changed to 0
	CHARACTER*(*) STR
	INTEGER OUTP,NUM
C	COMMON /GRAB5/OUTP,NUM,STR
	OUTP=0
	DO 100 I=1,NUM
	   IF (STR(I:I) .EQ. ' ') STR(I:I)='0'
	   IF ((STR(I:I).LT.'0') .OR. (STR(I:I).GT.'9')) THEN
	        RETURN(1)
		END IF
	   OUTP=OUTP*10+ICHAR(STR(I:I))-48
100	   CONTINUE
	RETURN
	END
*
