type arith.for
*
******************************************************************************
c			arith
*******************************************************************************
c	arith is the routine that sets up all the paarmeters for arithmetic
c	functions with the arrays. it then calls the correct subroutines to
c	perform those functions.
c------------------------------------------------------------------------------
	SUBROUTINE ARITH (OP,*)
c-------	op holds an integer that is the code for arith function
	INTEGER OP
c-------	twoarr is the logical for determining if 2 arrays are used
c-------	or just a number and one array
	LOGICAL TWOARR
c-------	the number that may be the argument
	REAL*4 REEL
c-------	the command and data blocks and the array pointers
	INTEGER ARRAY1,ARRAY2,LSTPT1,LSTPT2
	CHARACTER*1 CHARA
$INCLUDE:'DATARRAY.INC'
$INCLUDE:'COMMAND.INC'
$INCLUDE:'HEADER.INC'
c-----------------------------------------------------------------------------
c		program begins
c------------------------------------------------------------------------------
c------		get the arguments from the command
	CALL NOBLANX (COMM,PTR1,*400)
	CHARA=COMM(PTR1:PTR1)
	CHARA=CHARA
c-------	if the opcode is <74 then it is a single array , no argument
c------		arith function, or the arguments are asked for in the subrtne
	IF (OP .GT. 74) THEN
		CALL GETPTR (CHARA, ARRAY2,LSTPT2,*400)
		IF (OP .EQ. 75) CALL ZEROLOW (ARRAY2,LSTPT2)
		IF (OP .EQ. 76) CALL OFFSET (ARRAY2,LSTPT2)
		IF (OP .EQ. 77) CALL BANDPASS (ARRAY2,LSTPT2)
		IF (OP .EQ. 78) CALL NOSPIKE (ARRAY2,LSTPT2)
		IF (OP .EQ. 79) CALL CUM (ARRAY2,LSTPT2)
		IF (OP .EQ. 80) CALL SETHI (ARRAY2,LSTPT2)
		IF (OP .EQ. 81) CALL SQUARE (ARRAY2,LSTPT2)
		IF (OP .EQ. 82) CALL GETRATES (ARRAY2,LSTPT2)
		IF (OP .EQ. 83) CALL EVENTS (ARRAY2,LSTPT2)
		IF (OP .EQ. 84) CALL AVERAGE (ARRAY2,LSTPT2,0.0,.TRUE.)
		END IF
c-------	if op <25 then it can require 2 arrays or 1 number and an array
	IF (OP .LT. 25) THEN
		TWOARR=.FALSE.
c-------	seeif we come back with a valid array or not
		CALL GETPTR (CHARA,ARRAY1,LSTPT1,*175)
c-----------------------------------------------------------------------------
c-------		since we are here and not line 175, 2 arrays are used
		TWOARR=.TRUE. 
		REEL=-998.0
c--------		get the second array
		PTR1=PTR1+1
		CALL NOBLANX (COMM,PTR1,*400)
		CHARA=COMM(PTR1:PTR1)
		CHARA=CHARA
		CALL GETPTR (CHARA,ARRAY2,LSTPT2,*400)
		IF (LSTPT2 .NE. LSTPT1) THEN
			WRITE (*,*) ' ARRAYS DO NOT MATCH IN SIZE '
			GOTO 400
			END IF 	
c------------------------------------------------------------------------------
c---------		see if we came through the two array block
175		IF (.NOT. TWOARR) THEN
			ARRAY1=0
			LSTPT1=0
c----------			get the real number
			CALL GETREAL(REEL)
c---------			and the target array
			CALL NOBLANX (COMM,PTR1,*400)
			CHARA=COMM(PTR1:PTR1)
			CHARA=CHARA
			CALL GETPTR (CHARA,ARRAY2,LSTPT2,*400)
			END IF
c--------		and do the operation
		IF (OP .EQ. 1) CALL ADD (TWOARR,ARRAY1,ARRAY2,LSTPT2,REEL)
		IF (OP .EQ. 2) CALL SUB (TWOARR,ARRAY1,ARRAY2,LSTPT2,REEL)
		IF (OP .EQ. 3) CALL MUL (TWOARR,ARRAY1,ARRAY2,LSTPT2,REEL)
		IF (OP .EQ. 4) CALL DIV (TWOARR,ARRAY1,ARRAY2,LSTPT2,REEL)
		END IF
c------------------------------------------------------------------------------
c--------	if the op less than 50 and greater than 24 then it involves
c--------	a number and an array only
	IF ((OP .GE. 25) .AND. (OP .LT. 50)) THEN
c--------	get the variable to be passed and the array
		CALL GETREAL(REEL)
		IF ((REEL .LE. 0).AND.(OP .NE. 30)) GOTO 400
		CALL NOBLANX (COMM,PTR1,*400)
		CHARA=COMM(PTR1:PTR1)
		CHARA=CHARA
		CALL GETPTR (CHARA,ARRAY2,LSTPT2,*400)
c--------		and call the function
		IF (OP .EQ. 25) CALL AVERAGE (ARRAY2,LSTPT2,REEL,.FALSE.)
		IF (OP .EQ. 26) CALL VALPTS (ARRAY2,LSTPT2,REEL)
c		IF (OP .EQ. 27) CALL RUNMEAN (ARRAY2,LSTPT2,REEL)
		IF (OP .EQ. 28) CALL MOVAVG  (ARRAY2,LSTPT2,REEL)
		IF (OP .EQ. 29) CALL HIGHEST (ARRAY2,LSTPT2,REEL)
		IF (OP .EQ. 30) CALL PHASE (ARRAY2,LSTPT2,REEL)
		END IF
c-----------------------------------------------------------------------------
c--------	and finally if op is <75 and >49 it requires two arrays
	IF ((OP .GE.50) .AND. (OP .LT. 75)) THEN
		CALL GETPTR (CHARA,ARRAY1,LSTPT1,*400)
		PTR1=PTR1+1
		CALL NOBLANX (COMM,PTR1,*400)
		CHARA=COMM(PTR1:PTR1)
		CHARA=CHARA
		CALL GETPTR (CHARA,ARRAY2,LSTPT2,*400)
c--------		call the functions
		IF (OP .EQ. 50) CALL LSTSQR (ARRAY1,ARRAY2,LSTPT2,1)
		IF (OP .EQ. 51) CALL VECTOR (ARRAY1,ARRAY2,LSTPT2)
		IF (OP .EQ. 52) CALL MERGE  (ARRAY1,ARRAY2,LSTPT2)
c		IF (OP .EQ. 53) CALL MKSTATFL (ARRAY1,ARRAY2,LSTPT2)
		IF (OP .EQ. 54) CALL LSTSQR (ARRAY1,ARRAY2,LSTPT2,2)
		END IF
c-----------------------------------------------------------------------------
c--------		clean up the headers and print them out
	IF (HILO(1,ARRAY2).EQ. -100000000) THEN
		HILO(1,ARRAY2)=-998
		HILO(2,ARRAY2)=-998
		END IF
	ARRAY2=ARRAY2+1
	CALL SHOHDR(ARRAY2,0,*250)
250	RETURN (1)
400	WRITE (*,*) ' ARITHMETIC FUNCTION ABORTED BECAUSE OF ARGUMENT ERRO
     2R'
	RETURN (1)
	END
c------------------------------------------------------------------------------ 