C         *              
*************************************************************************
c		auto scale
c----------------------------------------------------------------------
c	auto scale gets the hi and lo scale values for a plot
c----------------------------------------------------------------------
	SUBROUTINE AUTOSCALE (SCALEHI,SCALELO)
c---------------------------------------------------------------------
c-------- hi and lo are the hi and lo points in the array
c		scalehi and scalelo are for the plot
	REAL*4 SCALEHI,SCALELO,DIFF,DUM1
	INTEGER EXP1,TEMP1
c-------------------------------------------------------------------
c--------- get the difference and make it a number between 1 and 10
c		with an exponent
	DIFF=SCALEHI-SCALELO
	DUM1=(ALOG10 (DIFF))
	EXP1=DUM1
	IF (DIFF .LT. 1.0) EXP1=EXP1-1
	DIFF=DIFF/ (10.0**EXP1)
c--------  put the true his and los into our 1 to 10 space
	SCALEHI=SCALEHI/(10.0**EXP1)
	SCALELO=SCALELO/(10.0**EXP1)
c---------------------------------------------------------------------
c--------- using the following table we get the proper range for the diff
	IF (DIFF .GE. 9.0) THEN
		RANGE=12.5
		OFFSET=0.5
	ELSE IF (DIFF .GE. 8) THEN
		RANGE=10.0
		OFFSET=0.5
	ELSE IF (DIFF .GE. 7) THEN
		RANGE=8.0
		OFFSET=0.5
	ELSE IF (DIFF .GE.(4.5)) THEN
		RANGE=7.5
		OFFSET=0.5
	ELSE IF (DIFF .GE. 3.75) THEN
		RANGE=5.0
		OFFSET=0.5
	ELSE IF (DIFF .GE. 2.0) THEN
		RANGE=4.0
		OFFSET=0.25
	ELSE IF (DIFF .GE. 1.5) THEN
		RANGE=2.5
		OFFSET=0.25
	ELSE IF (DIFF .GE. 1.25) THEN
		RANGE=2.0
		OFFSET=0.25
	ELSE
		RANGE=1.5
		OFFSET=0.25
		END IF
c--------------------------------------------------------------------
c-------- now find a convenient number to start the offset on
c-------- if we can use zero do it
	IF ((SCALEHI .LE. RANGE) .AND.(SCALELO .GE. 0.0)) THEN
		SCALEHI=RANGE*(10.0**EXP1)
		SCALELO=0.0
		RETURN
		END IF
	IF ((SCALELO .GE. (-RANGE)) .AND. (SCALEHI .LE. 0.0)) THEN
		SCALEHI=0.0
		SCALELO=(-1)*(RANGE*(10.0**EXP1))
		RETURN
		END IF
c---------------------------------------------------------------------
c--------- but that doesn't always happen so we try to find
c		a number using the offset so it lands on something readable
	SCALELO=SCALELO*(10.0**EXP1)
	OFFSET=OFFSET*(10.0**EXP1)
	RANGE=RANGE*(10.0**EXP1)
	TEMP1=SCALELO/OFFSET
	IF (SCALELO .LT. 0) TEMP1=TEMP1-1
	SCALELO=(TEMP1*OFFSET)
	SCALEHI=SCALELO+RANGE
	RETURN
	END
c----------------------------------------------------------------------------

