c****************************************************************************
*			average
******************************************************************************
c	average takes the argument num and averages every num points (including
c	invalid ones) in the array. it also makes sure that this new rate is
c	an integral divider into 1440 (minutes in a day)
c
c
c	addition - will automaticly average the data for the best time
c	performance when plotting the data. it does this by checking the
c	number of days
c-----------------------------------------------------------------------------
	SUBROUTINE AVERAGE (ARRAY,LSTPT,REEL,AUTO)
c-----------------------------------------------------------------------------
c-------	the data array , and the passed argument
$INCLUDE:'DATARRAY.INC'
	REAL*4 REEL,TOT,VALID
	INTEGER NUM
	LOGICAL AUTO
c-------	the header (to reset the data rate)
$INCLUDE:'HEADER.INC'
	INTEGER CUR_RATE,DAYS
c-------	the array pointers
	INTEGER ARRAY,LSTPT,NUPTR,LEFT
c-----------------------------------------------------------------------------
c--------	program begins
c-----------------------------------------------------------------------------
c--------	convert the passed reel to an integer
	NUM=REEL
	CUR_RATE=HDR(3,ARRAY+1)
	DAYS=HDR(2,ARRAY+1)
	IF (.NOT. AUTO) GOTO 80
c---------  if this a auto avg then we must determine the new rates
c				get the current rate and number of days in the plot
c
c			if the days are less than 10, no averaging is required -
c			just return
	IF (DAYS .LE. 10) THEN
		RETURN
	ELSE IF (DAYS .LE. 30) THEN 
		NEW_RATE=24
	ELSE IF (DAYS .LE. 60) THEN
		NEW_RATE=4
	ELSE 
		NEW_RATE=1
		END IF
c			determine the number to be used for the averageing
	IF (NEW_RATE .GE. CUR_RATE) RETURN
	NUM=CUR_RATE/NEW_RATE
c----------------------------------------------------------------------------
c--------	check to see if the new data rate is integral divsor of 1440
c--------		(minutes in a day)
80	IF (MOD(CUR_RATE,NUM) .NE. 0) THEN
		WRITE (*,*) ' NEW RATE NOT A MULTPLE OF OLD RATE - ABORTED '
		RETURN
		END IF
c-------	put the new rate in
	HDR(3,ARRAY+1)=CUR_RATE/NUM
c-----------------------------------------------------------------------------
c--------	do the averaging
	NUPTR=1
	CALL ZERO_HILO(9)
	DO 201 K=1,LSTPT,ARRSIZ
		CALL DISK_(ARRAY,.TRUE.)
		CALL ARR_END (K,LSTPT,LEFT)
	DO 200 I=1,LEFT,NUM
		VALID=0
		TOT=0
		DO 150 J=I,I+NUM-1
			IF (DATA(J,ARRAY) .NE. -998.) THEN
				VALID=VALID+1
				TOT=TOT+DATA(J,ARRAY)
				END IF
150			CONTINUE
		IF (VALID .EQ. 0) THEN 
			DATA(NUPTR,9)=-998.0
		ELSE
			DATA(NUPTR,9)=TOT/VALID
			CALL NU_HILO(DATA(NUPTR,9),9)
			END IF
		NUPTR=NUPTR+1
		IF (NUPTR .GT. ARRSIZ) CALL WR_SEG(NUPTR,ARRAY,9)
200		CONTINUE
201		CONTINUE
c			write the last record
	CALL WR_LAST (ARRAY,.TRUE.)
	CALL TOP (ARRAY)
c-----------------------------------------------------------------------------
	RETURN
	END
c----------------------------------------------------------------------------

