c*************************** plot i x y z ***********************************
c
c		plot is the plotting subroutine. its command syntax is as above
c		it divides the screen into i sections (1-4) and then plots
c		from the top down, the arrays named in order (x,y,z) are arrays
c		in the title example. the plotting calls are in igl7 so any
c		revisions of bob must be linked with igl7/opt.
c-----------------------------------------------------------------------------
c		revision
c		plot is also called from the command plot/pr. if the integer
c		passed to plot in the call is equal to 1 then a hard copy
c		of the plot is made.     10/29/84
c-----------------------------------------------------------------------------
c		revision
c		the argument copyp now directs the output to either ;
c		the screen of the terminal  copyp=0
c		pause between plots on 
c			the screen          copyp=1
c		the line printer            copyp=2
c		a disk file for the laser   copyp=3
c		xtra long plot sent to the
c		   printer for use with
c		   teledyne helicorders     copyp=4
c----------------------------------------------------------------------------
	SUBROUTINE BOBPLOT (COPYO,*)
c-----------------------------------------------------------------------------
c
c		the variables
c
c		the variables to determine where the output goes
c		and if we connect consecutive points
	INTEGER COPYP,PT,COPYO
c		the # of graphs
	INTEGER GRAPHS
c----------------------------------------------------------------------------
c		the graph boundaries and data boundaries
	REAL*4 GRAPHTOP,GRAPHBOT,GRAPHRT,GRAPHLFT,DATAHI,DATALO
	REAL*4 DATAHY,DATALY,DATAY,TOP_PAGE
c----------------------------------------------------------------------------
c		the time variables
	INTEGER JUL,MIN,HR,DAY,MON,YR
c---------------------------------------------------------------------------
c		the various plt header array parameters and variables
$INCLUDE:'PLTHDR.INC'
	CHARACTER*3 ZONEX
	CHARACTER*15 LABELX,LABELY
	CHARACTER*50 TITLEX,TITLEY
	CHARACTER*1 ARR
	INTEGER ARRPTR,ARRPTY
c---------------------------------------------------------------------------
c		the data and its pointers
$INCLUDE:'DATARRAY.INC'
	REAL*4 DUM1
	INTEGER LASTPT,TODO
c--------------------------------------------------------------------------
c		the command and its pointers
$INCLUDE:'COMMAND.INC'
c--------------------------------------------------------------------------
c		the array headers and call variables
	INTEGER RATE,DAYS,VAL
$INCLUDE:'HEADER.INC'	
	CHARACTER*4 STA
c------------------------------------------------------------------------
c		the graphics board, printer, and font
$INCLUDE:'GRAPHVAR.INC'
	INTEGER*2 STATUS,LDDRV,INIPLT,SLTYPE,GCLOSE,FPLOT
	INTEGER*2 LDFONT
c------------------------------------------------------------------------
c		the plotting scale factors and logical
	REAL*4 XFAC,YFAC,XCON,YCON,DATAPT,HILOINC,DUMRY,DUMRX
	INTEGER I_DATA
	LOGICAL LASTDRAW,DASH,XY,GOODPT
c		determining where the cursor is
	REAL*4 X_LOC,Y_LOC,BOT_LOC
c		the width for bar graphs and symbols
	REAL*4 BAR,SYMWID,FFT_SP
c		logicals for labeling
	LOGICAL LABELR
c		stuff for doing long plots on the line printer
	INTEGER VIEWS,DUMMYPTR
	REAL*4 LENGTH
c		an output for a laser file
	CHARACTER*13 LZR_FILE
c-------------------------------------------------------------------------
c		the active code begins
c-------------------------------------------------------------------------
c-------------------------------------------------------------------------
c		see if its an xy plot
	IF (COPYO .GT. 9) THEN
		XY=.TRUE.
		COPYP=MOD(COPYO,10)
		GRAPHS=1
	ELSE
		XY=.FALSE.	
c		get the # (max. of 10) of graphs and start the loop
		CALL NOBLANX (COMM,PTR1,*400)
		CALL IGETNUM(COMM)
c		the integer is returned in num
		IF (NUM .GT. 10) GOTO 400
		GRAPHS=NUM
		COPYP=COPYO
		END IF
c		unless copyp = 4 views =1
c		left and right boundary of the graph is set at (in inches)
	IF (COPYP .EQ. 4) THEN
		GRAPHLFT=0.001
		GRAPHRT=10.52
	ELSE
		GRAPHLFT=1.435
		GRAPHRT=9.6
		END IF
c		set up for graphics
	IF (COPYP .LE. 1) THEN
c			output goes to the screen, and perhaps snap or copier
		STATUS=LDDRV ('SCREEN.DRV$')
		STATUS=INIPLT(SCREEN,0)
		STATUS=LDFONT('FONT.SCN$')
	ELSE IF ((COPYP .EQ. 2).OR.(COPYP .EQ. 4)) THEN
c			output goes to the line printer
		STATUS=LDDRV ('PRINTER.DRV$')
		STATUS=INIPLT ('ERASEME.PRT$',0)
		STATUS=LDFONT('FONT.PRN$')
	ELSE IF (COPYP .EQ. 3) THEN
c			outout goes to a file for later laser printing
c			NOTE: the file must be printed using FPLOT.EXE
c			from the geograf utilities disk.  It can't be 
c			printed directly with a dos PRINT command
39		FORMAT(' NAME FOR LASER OUTPUT FILE : ',$)
		WRITE(*,39)
40		FORMAT(A12)
		READ(*,40) LZR_FILE
		LZR_FILE(13:13)='$'
		STATUS=LDDRV ('LASER.DRV$')
		STATUS=INIPLT (LZR_FILE,0)
		STATUS=LDFONT('FONT.PRN$')
		END IF
c			the width for squares and such
	SYMWID=0.125/2.0
c			for some printer plots we go through more than once
	CALL PLOTS(1)
	IF (COPYP .EQ. 2) CALL FACTOR (0.9)
	IF (COPYP .EQ. 3) CALL FACTOR (0.9)
	IF (COPYP .EQ. 4) CALL FACTOR (0.9)
	IF (TOP_LOG) THEN
		CALL SYMBOL(GRAPHLFT+0.075,7.70,0.25,TOPTITLE,0.0,35)
		TOP_PAGE=7.65
	ELSE
		TOP_PAGE=7.9
		END IF
	LABELR=.TRUE.
	ZONEX=TME
	DO 350 I=1,GRAPHS
c-------------------------------------------------------------------------
c		get which array we are plotting and process that info
110		CALL NOBLANX (COMM,PTR1,*370)
		ARR=COMM(PTR1:PTR1)
		PTR1=PTR1+1
c		see if its a null plot
		IF ((ARR .LT. 'A') .OR. (ARR .GT. 'H')) THEN
c				put the time scale on the bottom
			CALL XAXIS (.TRUE.,GRAPHBOT,GRAPHLFT,GRAPHRT,YR,JUL,
     2		ZONEX,HR,DAY,MON,DAYS,.FALSE.,TITLEX,.FALSE.)
			GOTO 350
			END IF
		CALL PLOT_INFO(ARR,ARRPTR,LASTPT,TITLEX,LABELX,DATAHI,
     2		DATALO,JUL,YR,DAYS,PT,*350)
c			if its an xy plot get the y axis array info
		IF (XY) THEN
			CALL NOBLANX (COMM,PTR1,*370)
			ARR=COMM(PTR1:PTR1)
			PTR1=PTR1+1
c			see if its a good value
			IF ((ARR .LT. 'A') .OR. (ARR .GT. 'H')) GOTO 350
c				get its info
			CALL PLOT_INFO(ARR,ARRPTY,LASTPT,TITLEY,LABELY,
     2			DATAHY,DATALY,JUL,YR,DAYS,PT,*350)
			END IF
		CALL TZONE(ZONEX,JUL,YR,HR)
		CALL MONDAY (JUL,YR,MON,DAY,*125)
c-----------------------------------------------------------------------------
c		determine the top and bottom axis boundaries
c		setup is total graph with the bottom 0.65" reserved
c		for labeling
125			GRAPHTOP=(TOP_PAGE-0.6)/GRAPHS*(GRAPHS-I+1)+0.6
			GRAPHBOT=(TOP_PAGE-0.6)/GRAPHS*(GRAPHS-I)+0.6
c-----------------------------------------------------------------------------
c			plot the axis
		IF (.NOT. XY) THEN
			IF (PT .NE. 7) THEN
			   CALL YAXIS(LABELR,GRAPHLFT,GRAPHTOP,GRAPHBOT,
     2			      DATAHI,DATALO,GRAPHS,LABELX,.FALSE.)
c				don't want the data values on the plot
c				if we do a line density plot
     			ELSE
			   CALL YAXIS(.FALSE.,GRAPHLFT,GRAPHTOP,GRAPHBOT,
     2			      DATAHI,DATALO,GRAPHS,LABELX,.FALSE.)
			   END IF
			CALL YAXIS(.FALSE.,GRAPHRT,GRAPHTOP,GRAPHBOT,DATAHI,
     2			DATALO,GRAPHS,LABELX,.TRUE.)
			CALL XAXIS(.FALSE.,GRAPHTOP,GRAPHLFT,GRAPHRT,YR,JUL,
     2			ZONEX,HR,DAY,MON,DAYS,LABELR,TITLEX,.TRUE.)
			CALL XAXIS(.FALSE.,GRAPHBOT,GRAPHLFT,GRAPHRT,YR,JUL,
     2			ZONEX,HR,DAY,MON,DAYS,.FALSE.,TITLEX,.FALSE.)
		ELSE
			GRAPHBOT=GRAPHBOT+.18
			CALL YAXIS(LABELR,GRAPHLFT,GRAPHTOP,GRAPHBOT,DATAHY,
     2			DATALY,GRAPHS,LABELY,.FALSE.)
			CALL YAXIS(.FALSE.,GRAPHRT,GRAPHTOP,GRAPHBOT,DATAHY,
     2			DATALY,GRAPHS,LABELY,.TRUE.)
			CALL XYAXIS (GRAPHTOP,GRAPHRT,GRAPHLFT,
     2			DATAHI,DATALO,LABELX,TITLEY,.FALSE.)
			CALL XYAXIS (GRAPHBOT,GRAPHRT,GRAPHLFT,
     2			DATAHI,DATALO,LABELX,TITLEY,.TRUE.)
			CALL XYXBOT (GRAPHLFT,GRAPHRT,GRAPHBOT,
     2				JUL,YR,DAYS)
			END IF
c-----------------------------------------------------------------------------
c			plot the data
c
c		get the scaling factors outside the loop so theyre done only
c		once. 
	IF (.NOT. XY) THEN
		XFAC=(GRAPHRT-GRAPHLFT)/LASTPT
		YFAC=(GRAPHTOP-GRAPHBOT)/(DATAHI-DATALO)
		XCON=GRAPHLFT-(XFAC*0.5)
		YCON=GRAPHBOT-YFAC*DATALO
		BAR=(GRAPHRT-GRAPHLFT)/LASTPT
	ELSE
		XFAC=(GRAPHRT-GRAPHLFT)/(DATAHI-DATALO)
		YFAC=(GRAPHTOP-GRAPHBOT)/(DATAHY-DATALY)
		XCON=GRAPHLFT-(XFAC*DATALO)
		YCON=GRAPHBOT-(YFAC*DATALY)
		END IF
c		put the cursor at the bottom of the page
	CALL PLOT(0.0,0.0,3)
c		and plot the points
	LASTDRAW=.FALSE.
c-------- get the style of the plot (0=lines, 1=points, 2=bar, 3=triangles,
c		4=squares,5=diamonds,6=circles)
	PT=STYLE(ARRPTR)
c-------- whether we are to draw the dashed line
	IF (.NOT. XY) THEN
		DASH=DASHES(ARRPTR)
	ELSE
		DASH=DASHES(ARRPTY)
		END IF
c		and loop thru the array
	DO 341 K7=1,LASTPT,ARRSIZ
		CALL DISK_(ARRPTR,.FALSE.)
		IF ((XY).AND.(ARRPTR .NE. ARRPTY))
     2		CALL DISK_(ARRPTY,.FALSE.)
		CALL ARR_END(K7,LASTPT,TODO)
	DO 340 J=1,TODO
		GOODPT=.TRUE.
		DATAPT=DATA(J,ARRPTR)
		IF ((DATAPT .EQ. -998.) .OR. (DATAPT .LT. DATALO) .OR.
     2		(DATAPT .GT. DATAHI)) THEN
     			GOODPT=.FALSE.
			IF (PT .LT. 3) LASTDRAW=.FALSE.
		ELSE IF (XY) THEN
			DATAY=DATA(J,ARRPTY)
			IF ((DATAY .EQ. -998.).OR.(DATAY .LT. DATALY)
     2			.OR. (DATAY .GT. DATAHY)) THEN
     				GOODPT=.FALSE.
				IF (PT .LT. 3) LASTDRAW=.FALSE.
				END IF
			END IF
c		drawem if you gotem
		IF (GOODPT) THEN
c		get the next location
			IF (.NOT. XY) THEN
				DUMRX=XCON+(J+K7-1)*XFAC
				DUMRY=YCON+YFAC*DATAPT
			ELSE
				DUMRX=XCON+XFAC*DATAPT
				DUMRY=YCON+YFAC*DATAY
				END IF
c			if the last point was valid then just draw; no move
c			unless we are plotting just points
			IF ((LASTDRAW) .AND. (PT .EQ.0)) THEN
				CALL PLOT(DUMRX,DUMRY,2)
				LASTDRAW=.TRUE.
c--------- 	are we in line/dash mode?
			ELSE IF ((PT.EQ.0).AND.(DASH)) THEN
c--------- as long as we are not still at the 0,0 location draw a dashed line
				CALL WHERE(X_LOC,Y_LOC)
				IF (X_LOC .NE. 0.0) THEN
c--------- not a first draw so do a dashed line
					STATUS=SLTYPE(2)
					CALL PLOT (DUMRX,DUMRY,2)
					STATUS=SLTYPE(1)
				ELSE
c---------	first time - do a point
					CALL PLOT(DUMRX,DUMRY,3)
					CALL PLOT(DUMRX,DUMRY,3)
					END IF
				LASTDRAW=.TRUE.				
			ELSE IF (PT .LT. 2) THEN
c---------   we just draw a point
			   CALL PLOT(DUMRX,DUMRY,3)
			   CALL PLOT(DUMRX,DUMRY,2)
			   LASTDRAW=.TRUE.
			ELSE IF (PT .EQ. 2) THEN
c-----				  its a bar graph
				CALL PLOT(DUMRX,DUMRY,3)
				CALL PLOT((DUMRX-BAR/2),DUMRY,2)
				CALL PLOT((DUMRX-BAR/2),GRAPHBOT,2)
				CALL PLOT((DUMRX+BAR/2),GRAPHBOT,2)
				CALL PLOT((DUMRX+BAR/2),DUMRY,2)
				CALL PLOT(DUMRX,DUMRY,2)
			ELSE IF (PT .EQ. 3) THEN
c----------- else we draw a dashed line and naturally a triangle
				IF ((.NOT. LASTDRAW).OR.(.NOT. DASH)) THEN
					CALL PLOT (DUMRX,DUMRY,3)
				ELSE
  					STATUS=SLTYPE(2)
					CALL PLOT (DUMRX,DUMRY,2)
					STATUS=SLTYPE(1)
					END IF
				CALL PLOT(DUMRX,DUMRY,2)
				CALL PLOT(DUMRX,DUMRY+SYMWID,3)
				CALL PLOT(DUMRX-SYMWID,DUMRY-SYMWID,2)
				CALL PLOT(DUMRX+SYMWID,DUMRY-SYMWID,2)
				CALL PLOT(DUMRX,DUMRY+SYMWID,2)
				CALL PLOT(DUMRX,DUMRY,3)
				LASTDRAW=.TRUE.
			ELSE IF (PT .EQ. 4) THEN
c------				  its a square
				IF ((.NOT. LASTDRAW).OR.(.NOT. DASH)) THEN
					CALL PLOT (DUMRX,DUMRY,3)
				ELSE
					STATUS=SLTYPE(2)
					CALL PLOT (DUMRX,DUMRY,2)
					STATUS=SLTYPE(1)
					END IF
				CALL PLOT(DUMRX,DUMRY,2)
				CALL PLOT(DUMRX+SYMWID,DUMRY+SYMWID,3)
				CALL PLOT(DUMRX+SYMWID,DUMRY-SYMWID,2)
				CALL PLOT(DUMRX-SYMWID,DUMRY-SYMWID,2)
				CALL PLOT(DUMRX-SYMWID,DUMRY+SYMWID,2)
				CALL PLOT(DUMRX+SYMWID,DUMRY+SYMWID,2)
				CALL PLOT(DUMRX,DUMRY,3)
				LASTDRAW=.TRUE.
			ELSE IF (PT .EQ. 5) THEN
c------				  its a diamond
				IF ((.NOT. LASTDRAW).OR.(.NOT. DASH)) THEN
					CALL PLOT (DUMRX,DUMRY,3)
				ELSE
					STATUS=SLTYPE(2)
					CALL PLOT (DUMRX,DUMRY,2)
					STATUS=SLTYPE(1)
					END IF
				CALL PLOT(DUMRX,DUMRY,2)
				CALL PLOT(DUMRX,DUMRY+SYMWID,3)
				CALL PLOT(DUMRX+SYMWID,DUMRY,2)
				CALL PLOT(DUMRX,DUMRY-SYMWID,2)
				CALL PLOT(DUMRX-SYMWID,DUMRY,2)
				CALL PLOT(DUMRX,DUMRY+SYMWID,2)
				CALL PLOT(DUMRX,DUMRY,3)
				LASTDRAW=.TRUE.
			ELSE IF (PT .EQ. 6) THEN
c------				  its a circle
				IF ((.NOT. LASTDRAW).OR.(.NOT. DASH)) THEN
					CALL PLOT (DUMRX,DUMRY,3)
				ELSE
					STATUS=SLTYPE(2)
					CALL PLOT (DUMRX,DUMRY,2)
					STATUS=SLTYPE(1)
					END IF
				CALL PLOT(DUMRX,DUMRY,2)
				CALL SYMBOL(DUMRX-SYMWID,DUMRY-SYMWID,
     2				(SYMWID*2),'O',0.0,1)
				CALL PLOT(DUMRX,DUMRY,3)
				LASTDRAW=.TRUE.
			ELSE IF (PT .EQ. 7) THEN
c-----				  its a line density (FFT) graph
c				  the data is assumed to be in % values
c				  100% or greater will draw 100 horizontal
c				  lines in the time slots area. 1% will
c				  draw 1 line, etc. 0% will also draw 1 to 
c				  indicate a valid data point 
c
c				  get the vertical spacing of the lines
				IF (DATAPT .GT. 100) DATAPT=100
				IF (DATAPT .LT. 1) DATAPT=1	
				I_DATA=DATAPT		
				FFT_SP=(GRAPHTOP-GRAPHBOT)/(I_DATA+1)
c				  loop through drawing the points
				DO 330 FF=1,I_DATA
				  DUMRY=GRAPHBOT+FF*FFT_SP
				  CALL PLOT(DUMRX-BAR/2,DUMRY,3)
				  CALL PLOT(DUMRX+BAR/2,DUMRY,2)
330				  CONTINUE
				END IF
			END IF
340		CONTINUE	
341		CONTINUE
	CALL TOP(ARRPTR)
	IF (XY) CALL TOP (ARRPTY)
c------------------------------------------------------------------------------
c		if the next character is a plus sign, we are to draw another
c		graph on top of the one just drawn
		CALL NOBLANX (COMM,PTR1,*350)
		ARR=COMM(PTR1:PTR1)
		IF (ARR .EQ. '+') THEN
c------				labelr will supress label and titles on this
c				graph. the label and titles will remain from 
c				the graph it is overwriting
			LABELR=.FALSE.
			PTR1=PTR1+1
			GOTO 110
		ELSE
			LABELR=.TRUE.
			END IF

350		CONTINUE
c-----------------------------------------------------------------------------
c		put the time scale on the bottom
370	IF ((GRAPHBOT .GT. 0) .AND. (.NOT. XY)) THEN
		CALL XAXIS(.TRUE.,GRAPHBOT,GRAPHLFT,GRAPHRT,YR,JUL,ZONEX,
     2		HR,DAY,MON,DAYS,.FALSE.,TITLEX,.FALSE.)
		END IF
c----------------------------------------------------------------------------
c			type a <cr> to get out of grapics mode
	IF (COPYP .EQ. 0) THEN
		CALL GWAIT (-1)
		END IF
c			wait 45 seconds and then continue
	IF (COPYP .EQ. 1) CALL GWAIT (20)
	CALL PLOT (0.0,0.0,999)
	STATUS=GCLOSE()
	IF ((COPYP .EQ. 2).OR.(COPYP .EQ. 4)) THEN
		STATUS=LDDRV ('PRINTER.DRV$')
		STATUS=INIPLT (PRINTER,0)
		STATUS=FPLOT ('ERASEME.PRT$',0)
		STATUS=GCLOSE()
c			erase the buffer file
		COMM(5:40)=' DEL ERASEME.PRT                    '
		CALL SPAWN(*399)
	ELSE
		COMM(5:40)=' CLS                                '
		CALL SPAWN(*399)
		END IF
c-----------------------------------------------------------------------------
399	RETURN(1)
400	WRITE(*,*) 'ERROR IN ARGUMENTS'
	RETURN(1)
	END
c------------------------------------------------------------------------------

