*******************************************************************************
c			fill
******************************************************************************
c------fill grabs data from the files as per the working header and puts the 
c------data in the array specified by its argument. the file types accessed by
c------fill are RAW, CLN, DAY, and HUR. when filling from RAW or CLN, the
c------points/day will be read in from the file as goes data may be anything
c------from 288 to 24 points/day in its raw format. files DAY and HUR have 
c------rates of 1 and 24 points/day respectively.
c------the data arrays are set up as 4 partions of a single large array. each
c------array can hold 57,000 data points (1 leap year at 144 points/dat) but
c------the arrays are configured such that if you read in more than 57,000 
c------points for a it will over run first array b, then c, and so on. array b 
c------can overun c and d, while c can only overrun d. therefore, if you dont 
c------any other array a can hold 4*57,000 datapoints, or by not using b and d
c------both a and c can hold 2*57,000 points (2 years of 10 minute data).
******************************************************************************
	SUBROUTINE FILL (*)
c			declare the variables
c		the array (1=a,b=2,c=3,d=4), and its pointer
	INTEGER A1,ARRPTR,DUM1
c		the data array
$INCLUDE:'DATARRAY.INC'
c		the various header arrays
$INCLUDE:'HEADER.INC'
c		the plot headers
$INCLUDE:'PLTHDR.INC'
c		the working header variables
	INTEGER BJL,DAYS,BYR,RATE
	CHARACTER*4 STA,CHNL
	CHARACTER*3 FILTYP
c		the variables to read in the data
	REAL*4 DLINE(1440)
	CHARACTER*5760 LINE
	EQUIVALENCE (DLINE,LINE)
	LOGICAL OPENED
c		the command block to get the array
$INCLUDE:'COMMAND.INC'
	CHARACTER*1 CHARA
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c			program begins
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c		find which array is to be filled
	CALL NOBLANX(COMM,PTR1,*420)
	CHARA=COMM(PTR1:PTR1)
	IF ((CHARA .GE. 'A') .AND. (CHARA .LE. 'H')) THEN
		CALL GETPTR(CHARA,A1,DUM1,*90)
	ELSE
		GOTO 420
		END IF
c		get the parameters out of the working header. if the 
c		header is incomplete, bail out to line 400.
90	CALL CHKHDR(BJL,DAYS,BYR,STA,CHNL,RATE,FILTYP,*400)
c		construct the filename.filename is of the form stid:chidyr.typ.
c		also open the file, check for its existence and its rate
c		the argument 0 in dicates the working header. file is
c		opened as unit 2.  if we discover it was a qplot style file
c		we fill it before returning and go down to lin #210
c		to reset the header
	CALL OPFILE(1,STA,CHNL,BYR,FILTYP,RATE,A1,OPENED,*400,*210)
c-------------------------start reading in the data
150	FORMAT(A)
	ARRPTR=1
	WR_ARRAY(A1)=1
	RD_ARRAY(A1)=1
	CALL ZERO_HILO(A1)
	DO 200 I=1,DAYS
c			data is read from the files one daya at a time.
c			julian day one is record #2.
c			but we can only read data from an opened file
		IF (OPENED) THEN
			READ(2,REC=BJL+1,ERR=190) LINE(1:RATE*4)
		ELSE
			DO 155 J=1,RATE
				DLINE(J)=-998.0
155				CONTINUE
			END IF	
c			put the data in the array		
		DO 180 J=1,RATE
			DATA(ARRPTR,A1)=DLINE(J)
			CALL NU_HILO(DATA(ARRPTR,A1),A1)
			ARRPTR=ARRPTR+1
c				see if we have to put part of the array to disk
			IF (ARRPTR .GT. ARRSIZ) THEN
				IF (WR_ARRAY(A1).EQ.1) CALL DISK_OP(A1) 
				WRITE(UNIT=(49+A1),REC=WR_ARRAY(A1)) C_ARRAY(A1)
				WR_ARRAY(A1)=WR_ARRAY(A1)+1
				ARRPTR=1
				END IF
180			CONTINUE
		GOTO 195
c-----------------------with an error in reading file, put in null data
190		DO 191 J=1,RATE
			DATA(ARRPTR,A1)=-998.0
			ARRPTR=ARRPTR+1
c				see if we have to put part of the array to disk
			IF (ARRPTR .GT. ARRSIZ) THEN
				IF (WR_ARRAY(A1).EQ.1) CALL DISK_OP(A1)
				WRITE(UNIT=(49+A1),REC=WR_ARRAY(A1)) C_ARRAY(A1)
				WR_ARRAY(A1)=WR_ARRAY(A1)+1
				ARRPTR=1
				END IF
191			CONTINUE
c-----------------------get next day and see if it is in a new year(new file)
195		BJL=BJL+1
		IF ((BJL .GT.366).OR.((BJL .GT.365) .AND. 
     2		(MOD(BYR,4) .NE. 0))) THEN
			IF (I .NE. DAYS) THEN
				BYR=BYR+1
				BJL=1
				CLOSE (2)
				CALL OPFILE(1,STA,CHNL,BYR,FILTYP,
     2				RATE,A1,OPENED,*400,*210)
				END IF
			END IF
200		CONTINUE
	CLOSE(2)
c****************************************************************************
c			set up the new header for our just filled array
210	DO 220 I=1,4
		HDR(I,A1+1)=HDR(I,1)
220		CONTINUE
	STID(A1*4+1:A1*4+4)=STID(1:4)
	CHID(A1*7+1:A1*7+7)=CHID(1:7)
	DO 225 I=A1*50-49,A1*50
		TITLE(I:I)=' '
225		CONTINUE
	TITLE(A1*50-49:A1*50-46)=STID(1:4)
	TITLE(A1*50-44:A1*50-41)=CHID(1:4)
	LABEL(A1*15-14:A1*15)='               '
	SCALE(1,A1)=-998.0
	SCALE(2,A1)=-998.0
	STYLE(A1)=0
	DASHES(A1)=.FALSE.
	IF (HILO(1,A1) .EQ. -100000000) HILO(1,A1)=-998
	IF (HILO(2,A1) .EQ. +100000000) HILO(2,A1)=-998
	IF (WR_ARRAY(A1) .NE. 1) THEN
		WRITE(UNIT=A1+49,REC=WR_ARRAY(A1)) C_ARRAY(A1)
		END IF
	CALL TOP(A1)
	DUM1=A1+1
	CALL SHOHDR(DUM1,0,*390)
******************************************************************************
c			just the returns
390	RETURN(1)
c----------------------------------------------------------------------------
400	WRITE(*,*) ' FILL ABORTED'
	RETURN(1)
420 	CALL ERARG(*390)
	END
******************************************************************************

