c
******************************************************************************
*			lstsqr
******************************************************************************
c	lstsqr does a least squares fit to the data in the 2 specified arrays.
c	data in the arrays is not changed, merely the equation for line
c	and a number for the 'fit' are displayed on the screen.
c----------------------------------------------------------------------------
	SUBROUTINE LSTSQR (ARRAY1,ARRAY2,LSTPT2,ROLE)
c-----------------------------------------------------------------------------
c-------	the data array 
$INCLUDE:'DATARRAY.INC'
c-------	the array pointers
	INTEGER ARRAY1,ARRAY2,LSTPT2,LEFT
c-------	indicator if we actaully correct the data in array1
	INTEGER ROLE
c-------	and the variables for calculating the lst sqres
	REAL*8 X,Y,X2,Y2,XY,N,SSE,XX,YY,XAV,YAV
	REAL*4 A,B,R2,VARI,DEV
c-----------------------------------------------------------------------------
c--------	program begins
c-----------------------------------------------------------------------------
c--------	the formula used is the one used in the statistics manual for
c--------	the hp-41, chapter 6 page 87.
c--------	we first go through the two arrays calculating variables for
c-------- 	use later on, initializing all the variables.
	N=0.0
	XY=0.0
	X=0.0
	Y=0.0
	X2=0.0
	Y2=0.0
	DO 101 K=1,LSTPT2,ARRSIZ
		CALL DSK_OV2(ARRAY1,ARRAY2,.FALSE.,K,LSTPT2,LEFT)
	DO 100 I=1,LEFT
		IF ((DATA(I,ARRAY1) .EQ. -998) .OR. (DATA(I,ARRAY2) .EQ.
     2    -998)) GOTO 100
		N=N+1
		X=X+DATA(I,ARRAY1)
		Y=Y+DATA(I,ARRAY2)
		XY=XY+DATA(I,ARRAY1)*DATA(I,ARRAY2)
		X2=X2+DATA(I,ARRAY1)*DATA(I,ARRAY1)
		Y2=Y2+DATA(I,ARRAY2)*DATA(I,ARRAY2)
100		CONTINUE
101		CONTINUE
	CALL TOP(ARRAY1)
	CALL TOP(ARRAY2)
	XAV=X/N
	YAV=Y/N
	XX=X2-(X*X)/N
	YY=Y2-(Y*Y)/N
	XY=XY-((X*Y)/N)
c----------------------------------------------------------------------------
c--------	make sure we got at least 2 points
	IF (N .LT.2) THEN
		WRITE(*,*)' LESS THAN TWO VALID POINTS - ABORTED'
		RETURN
		END IF
c--------	make the calculations for a,b,r2
	B=XY/XX
	A=YAV-(B*XAV)
	R2=XY*XY/(XX*YY)
c		get the variance of the data from the fitted line
	SSE=YY-(B*XY)
	VARI=SSE/(N-2)
c		and the standard deviation
	DEV=SQRT(ABS(VARI))
c---------------------------------------------------------------------------
c--------	print them out
	WRITE(*,*) ' FORMULA IS ARRAY2=B*ARRAY1+A .'
	WRITE(*,*) ' R2 LIES BETWEEN 0 AND 1 WITH ONE BEING A PERFECT LINE
     2.'
120	FORMAT(1X,'A= ',F10.4,' B= ',F10.4,' R2= ',F10.4,' VALID POINTS=
     2 ',F7.1) 
	WRITE (*,120) A,B,R2,N
130	FORMAT(' VARIANCE= ',F12.4,'  STNDRD DEVIATION= ',F12.4)
	WRITE(*,130) VARI,DEV
c----------------------------------------------------------------------------
c--------	see if we are to correct array1 using the above variables
	IF (ROLE .EQ. 2) THEN
c--------		go through array1 and correct it
		CALL ZERO_HILO(ARRAY1)
		DO 201 K=1,LSTPT2,ARRSIZ
			CALL DISK_(ARRAY1,.FALSE.)
			CALL ARR_END(K,LSTPT2,LEFT)
		DO 200 I=1,LEFT
			IF (DATA(I,ARRAY1) .NE. -998.) THEN
				DATA(I,ARRAY1)=A+(B*DATA(I,ARRAY1))
				CALL NU_HILO(DATA(I,ARRAY1),ARRAY1)
				END IF
200			CONTINUE
201 			CONTINUE
		CALL WR_LAST(ARRAY1,.FALSE.)
		CALL TOP(ARRAY1)
c--------		show the new data
		ARRAY1=ARRAY1+1
		CALL SHOHDR (ARRAY1,0,*220)
220		ARRAY1=ARRAY1-1
		END IF
c----------------------------------------------------------------------------
	RETURN
	END
c----------------------------------------------------------------------------

