******************************************************************************
c			movavg
c***************************************************************************
c	movavg computes a moving average between successive valid data points
c	even though they may be seperated by large numbers of missing data 
c	points. no data points are filled in, a aveage is computed only
c	where a valid data point existed before. the user is prompted for
c	how many valid points are needed before the average can be first
c	computed. remember that phase shifts in the data can happen when
c	using this command.
c--------------------------------------------------------------------------
	SUBROUTINE MOVAVG(ARRAY,LSTPT,REEL)
c--------------------------------------------------------------------------
c-------- the data arrays and the passed arguments
$INCLUDE:'DATARRAY.INC'
	REAL*4 REEL
	INTEGER LSTPT,NUM, ARRAY,LEFT
c------- the pointers and data holders
	INTEGER POINTER,NECESSARY,VALID
	REAL*4 TOTAL,TEMP1
c-------- the executable file i/o
$INCLUDE:'EXEC.INC'
c-----------------------------------------------------------------------------
c
c			program begins
c-----------------------------------------------------------------------------
c------- convert the passed argument to an integer
	NUM=REEL
	IF (NUM .GT. 1440) THEN
		WRITE(*,*) ' MAXIMUM NUMBER OF POINT TO AVERAGE OF 1440 EXCE
     2EDED. TRY AGAIN'
		RETURN
		END IF
c------
100	FORMAT(' WHAT IS THE MINIMUM NUMBER OF VALID DATA POINTS NECESSARY
     2')
110	FORMAT(' TO COMPUTE THE MEAN ? ',$)
115	WRITE(*,100)
	WRITE(*,110)
	READ(UNITR,*,ERR=115) NECESSARY
	IF (SAVECOMM) THEN
		WRITE(10,*)NECESSARY
		END IF
c-----------------------------------------------------------------------------
c------ initialize some things
	VALID=0
	TOTAL=0
	POINTER=1
	DO 130 J=1,NUM
		DATA(J,9)=-998
130		CONTINUE
	CALL ZERO_HILO(ARRAY)
c------ and do it
	DO 201 K=1,LSTPT,ARRSIZ
		CALL DISK_(ARRAY,.FALSE.)
		CALL ARR_END(K,LSTPT,LEFT)
	DO 200 J=1,LEFT
c------	take out the last value if we have a new point
		IF (DATA(J,ARRAY) .NE. -998) THEN
			TEMP1=DATA(POINTER,9)
			IF (TEMP1 .NE. -998) THEN
				TOTAL=TOTAL-TEMP1
				VALID=VALID-1
				END IF
c------ put in the new point into buffer and comput the mean
			TEMP1=DATA(J,ARRAY)
			DATA(POINTER,9)=TEMP1
			TOTAL=TOTAL+TEMP1
			VALID=VALID+1
			IF (VALID .GE. NECESSARY) THEN
				DATA(J,ARRAY)=TOTAL/VALID
				CALL NU_HILO(DATA(J,ARRAY),ARRAY)
			ELSE
				DATA(J,ARRAY)=-998
				END IF
c---- reset the pointer for the next round
			POINTER=(MOD(POINTER,NUM)+1)
			END IF
200		CONTINUE
201		CONTINUE
c--------------------------------------------------------------------
	CALL WR_LAST(ARRAY,.FALSE.)
	CALL TOP(ARRAY)
	RETURN
	END
c--------------------------------------------------------------------	        

