*******************************************************************************
c		qplot
*******************************************************************************
c	qplot takes all the data and puts it a qplot style file. qplot
c	assumes all arrays have the same data rate as array #1 and the same
c	length as array #1 (a).
c-----------------------------------------------------------------------------
	SUBROUTINE QPLOT(*)
c-----------------------------------------------------------------------------
c		first our cast of characters
c-----------------------------------------------------------------------------
	INTEGER JL,DAY,MON,YR,MIN,HR,DAYS,RATE,ARRPTR
	LOGICAL WRITE_IT
	CHARACTER*4 STA
	CHARACTER*12 FILE
	CHARACTER*3 C_MONTH
	INTEGER COLUMN(8),ARRAYS,ARR,DUM1,LEFT,LSTPT
c--------
$INCLUDE: 'DATARRAY.INC'
$INCLUDE: 'EXEC.INC'
$INCLUDE: 'HEADER.INC'
$INCLUDE: 'COMMAND.INC'
c------------------------------------------------------------------------------
c		see what arrays are supposed to be put out
	ARRAYS=0
10	CALL NOBLANX(COMM,PTR1,*30)
	ARR=ICHAR(COMM(PTR1:PTR1))-64
	PTR1=PTR1+1
	IF ((ARR.LT.1).OR.(ARR.GT.8)) CALL ERARG(*400)
	ARRAYS=ARRAYS+1
	COLUMN(ARRAYS)=ARR
c		see if there is more
	GOTO 10
30	IF (ARRAYS .EQ. 0) CALL ERARG(*400)
c		make sure they haven't used the same array twice like
c			eur_file a a
	IF (ARRAYS .GT. 1) THEN
		DO 34 I=2,ARRAYS
			DO 33 J=1,I-1
			   IF (COLUMN(J) .EQ. COLUMN (I)) CALL ERARG(*400)
33			   CONTINUE
34			CONTINUE
		END IF
c--------	code begins by getting the start time out of the first array
	ARR=COLUMN(1)+1
	JL=HDR(1,ARR)
	DAYS=HDR(2,ARR)
	YR=HDR(4,ARR)
	RATE=HDR(3,ARR)	
c--------	before going any farther make sure that all the arrays have
c		the same rate and time period
	DO 35 I=1,ARRAYS
		DUM1=COLUMN(I)+1
		IF (JL .NE. HDR(1,DUM1)) GOTO 500
		IF (DAYS .NE. HDR(2,DUM1)) GOTO 500
		IF (YR .NE. HDR(4,DUM1)) GOTO 500
		IF (RATE .NE. HDR(3,DUM1)) GOTO 500
35 		CONTINUE
c		the qplot file created will have the stid and bjl
c	FILE(1:12)='            '
36	FORMAT(' FILE NAME? ',$)
37	FORMAT (A12)
	WRITE(*,36)
	READ(*,37) FILE
c	FILE(1:4)=STID((4*DUM1)-3:(4*DUM1))
c	DUM1=JL/100
c	FILE(6:6)=CHAR(DUM1+48)
c	FILE(8:8)=CHAR(48+MOD(JL,10))
c	FILE(7:7)=CHAR(48+((JL-DUM1*100)/10))
c--------	open our target file
	OPEN(UNIT=2,FILE=FILE,STATUS='NEW',ERR=450)
c-------	get real start time for different time zones
c40	FORMAT(A18,$)
c	WRITE(6,*) ' GMT,LOC,HST,PST,EST, OR PDT? '
c50	FORMAT(A3)
c	READ(UNITR,50) TIMZON
c	IF (SAVECOMM) THEN
c		WRITE(10,50)TIMZON
c		END IF
C	TIMZON='HST'
c	CALL TZONE(TIMZON,JL,YR,HR)
c--------	convert the julian time to month/day time
	CALL MONDAY (JL,YR,MON,DAY,*100)
100	CALL MON_2_INT(C_MONTH,MON,.TRUE.)
	MIN=0.0
	YR=MOD(YR,100)
c--------	and start filling the file
	LSTPT=DAYS*RATE
	DO 160 K=1,LSTPT,ARRSIZ
		DO 105 L=1,ARRAYS
			CALL DISK_(COLUMN(L),.FALSE.)
105			CONTINUE
		CALL ARR_END(K,LSTPT,LEFT)
	DO 150 N=1,LEFT
110		FORMAT(I2.2,'-',A3,'-',I2.2,1X,I2.2,':',I2.2,8(1X,F9.3))
c			if its all -998 then don't bother to write it
		WRITE_IT=.FALSE.
		DO 120 J=1,ARRAYS
			IF (DATA(N,COLUMN(J)) .NE. -998.0) WRITE_IT=.TRUE.
120			CONTINUE
		IF (WRITE_IT) THEN
			WRITE(2,110) DAY,C_MONTH,YR,HR,MIN,
     2			(DATA(N,COLUMN(J)),J=1,ARRAYS)
			END IF
c---------		increment the time to the next data point
	    MIN=MIN+1440/RATE
c---------	convert in julian days first and the convert to month/day
	    CALL TIMEFIX (YR,JL,HR,MIN)
        CALL MONDAY (JL,YR,MON,DAY,*140)
140		CALL MON_2_INT(C_MONTH,MON,.TRUE.)
150	  CONTINUE
160	  CONTINUE
	DO 170 L=1,ARRAYS
		CALL TOP(COLUMN(L))
170		CONTINUE
c---------------------------------------------------------------------------
c--------	almost all done
175	FORMAT(1X,'DATA WRITTEN OUT TO FILE ',A12)
	WRITE(6,175) FILE
	CLOSE(2)
400	RETURN(1)
445	FORMAT(1X,'ERROR IN OPENING FILE ',A12)
450	WRITE(*,445) FILE
	WRITE(*,*) ' IT PROBALY ALREADY EXISTS. USE BOBS DOS'
	WRITE(*,*) ' COMMAND TO EXECUTE A RENAME COMMAND.'
	RETURN(1)	
500	WRITE(*,*) ' TIME AND/OR DATA RATES OF ARRAYS ARE NOT EQUAL '
	WRITE(*,*) ' OPERATION ABORTED.'
	RETURN(1)
	END
c---------------------------------------------------------------------------
