********************************************************************************
c			qplot_open
c******************************************************************************
c		qplot open checks to see if there is a qplot format file in
c	the defaultfile directory.  if so, this indicates that some qplt
c	files have been set up for bob to access.  qplot_open looks through 
c	this file and if the stid:chid match it opens that qplot file and
c	reads it instaed of searching for bob file.  the qplot format file
c	defines the qplot file and the data format.
c----------------------------------------------------------------------------
	SUBROUTINE QPL_OPEN (ARRAY, BJL, DAYS, BYR, RATE,
     2	STID_DIR,PTR3,DESIG,*,*)
c-----------------------------------------------------------------------------
c		our characters - header variables
	INTEGER ARRAY,BJL,BYR,RATE,DUM_RATE,DAYS
c		the stid-chid
	CHARACTER*22 SEARCHFILE
C	CHARACTER*13 DEFAULTFILE
	CHARACTER*80 QPLOTFILE
	CHARACTER*60 STID_DIR
	CHARACTER*24 DESIG
c		stuf for accessing multiple qplot files
	INTEGER PTR3,FMONTH,FYEAR,ENDMONTH,BMONTH,YR_SPOT,MMM_SPOT
	INTEGER DD_SPOT,FDAY,ENDDAY
	LOGICAL EXST,YR_LOG,MMM_LOG,DD_LOG
	CHARACTER*3 CMONTH(12)
c		the file line
	CHARACTER*80 LINE
c		the format
	CHARACTER*45 FORMT
c		the time
	INTEGER MONTH,DAY,YEAR,HOUR,MINUTE,ENDJUL,ENDYEAR
	CHARACTER*3 ZONE,CMON
c		some variables to keep track of points in the lines
	INTEGER PTR1,PTR2
c		the data
$INCLUDE:'DATARRAY.INC'
	REAL*4 DATAPOINT
	INTEGER LAST,LEFT
c		the macros stuff
$INCLUDE:'EXEC.INC'
	DATA CMONTH/'JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG',
     2	'SEP','OCT','NOV','DEC'/
c------------------------------------------------------------------------------
c			showtime
c		see if the bob_qplot file exists
	DO 90 I=1,80
		QPLOTFILE(I:I+10)='          '
90		CONTINUE
	QPLOTFILE(1:PTR3)=STID_DIR(1:PTR3)
	QPLOTFILE(PTR3+1:PTR3+13)='BOB_QPLOT.TXT'
	INQUIRE (EXIST=EXST,FILE=QPLOTFILE)
	IF (.NOT. (EXST)) RETURN
c		it exists, so we gots to see if we have a match
c		first construct the match name (delete the year as qplot files
c		don't use the year in their filename
	SEARCHFILE(1:18)=DESIG(1:18)
	SEARCHFILE(19:22)=DESIG(21:24)
	OPEN(UNIT=2,FILE=QPLOTFILE,STATUS='OLD',MODE='READ',ERR=400)
c		read the lines searching for a match	
100	FORMAT(A80)
110	READ(2,100,ERR=400,END=250) LINE
	IF (LINE(1:22) .NE. SEARCHFILE) GOTO 110
c		we have a match !!  get the qplot file name and the format
	PTR1=23
	DO 112 I=PTR3+1,80
		QPLOTFILE(I:I)=' '
112		CONTINUE
	FORMT(1:15)='               '
	FORMT(16:30)=FORMT(1:15)
	FORMT(31:45)=FORMT(1:15)
	ZONE='   '
	PTR1=23
	CALL GET_FIELD(LINE,PTR1,QPLOTFILE(PTR3+1:80),30,*400)
	CALL GET_FIELD(LINE,PTR1,FORMT,45,*400)
	CALL GET_FIELD(LINE,PTR1,ZONE,3,*400)
	CLOSE(2)
c-------------------------------------------------------------------------
c		get the data rate desired and -998 the array
115	FORMAT(' HOW MANY POINTS/DAY DO YOU WANT FOR THIS FILL ? ',$)
	WRITE(*,115)
	READ(UNITR,*,ERR=460) DUM_RATE
	IF (DUM_RATE .LE. 0) GOTO 460
	IF (SAVECOMM) THEN
		WRITE(10,*) DUM_RATE
		END IF
c		make sure its a valid rate (integer divisor 1440 ; minutes/day)
	IF (MOD(1440,DUM_RATE) .NE. 0) GOTO 460
c--------------------------------------------------------------------------
c		with that info, first -998 out the array
	RATE=DUM_RATE
	LAST=DAYS*RATE
	DO 150 I=1,ARRSIZ
		DATA(I,ARRAY)=-998.0
150		CONTINUE
	CALL DISK_OP(ARRAY)
	DO 151 K=1,(LAST/ARRSIZ)+1
		WRITE(UNIT=49+ARRAY,REC=K) C_ARRAY(ARRAY)
151		CONTINUE
	CALL TOP (ARRAY)
c		it makes things easier to know the ending julian day and year
	CALL END_TIME(BJL,BYR, ENDJUL,ENDYEAR,DAYS)
	CALL MONDAY(ENDJUL,ENDYEAR,ENDMONTH,DAY,*135)
135	ENDDAY=DAY
	FYEAR=BYR
	CALL MONDAY(BJL,BYR,BMONTH,DAY,*152)
152	FMONTH=BMONTH
	FDAY=DAY
c--------------------------------------------------------------------------
c		see if we are to access multiple files of differing years
c		or months.  if the files need a year in the title, they'll
c		have the string 'yy' in the name, for the month, 'mmm'.
c		if the filename uses those strings as part of the real name
c		put make them uppercase to differentiate from the year and month
c		designation.
c			dd added for day of the month
	YR_LOG=.FALSE.
	MMM_LOG=.FALSE.
	DD_LOG=.FALSE.
	IF (INDEX(QPLOTFILE,'yy') .NE. 0) THEN
		YR_SPOT=INDEX(QPLOTFILE,'yy')
		YR_LOG=.TRUE.
		END IF
	IF (INDEX(QPLOTFILE,'mmm') .NE. 0) THEN
		MMM_SPOT=INDEX(QPLOTFILE,'mmm')
		MMM_LOG=.TRUE.
		END IF
	IF (INDEX(QPLOTFILE,'dd') .NE. 0) THEN
		DD_SPOT=INDEX(QPLOTFILE,'dd')
		DD_LOG=.TRUE.
		END IF
c-----------------------------------------------------------------------------
c		if needed, insert the proper month and/or year in the file name

153	IF (YR_LOG) THEN
		CALL ICONVERT(FYEAR,QPLOTFILE(YR_SPOT:YR_SPOT+1),2)
		END IF
	IF (MMM_LOG) THEN
		QPLOTFILE(MMM_SPOT:MMM_SPOT+2)=CMONTH(FMONTH)
		END IF
	IF (DD_LOG) THEN
		CALL ICONVERT(FDAY,QPLOTFILE(DD_SPOT:DD_SPOT+1),2)
		END IF
c		since we use month, day and year sometimes, the specific
c		file may not exist. check it here or else errors result
	INQUIRE (EXIST=EXST,FILE=QPLOTFILE)
	IF (.NOT. (EXST)) GOTO 500
c		open the qplot file and start reading the data
	OPEN(UNIT=2,FILE=QPLOTFILE,STATUS='OLD',MODE='READ',ERR=500)
155	READ(2,FMT=FORMT,END=500,ERR=300) DAY,CMON,YEAR,
     2	HOUR,MINUTE,DATAPOINT
	CALL MON_2_INT(CMON,MONTH,.FALSE.)
	IF (MONTH .EQ. 0) GOTO 155
	CALL GETJUL(JUL,YEAR,MONTH,DAY)
c		see if its in our interested period
	IF (YEAR .LT. BYR) GOTO 155
	IF ((YEAR .EQ. BYR) .AND. (JUL .LT. BJL)) GOTO 155
	IF (YEAR .GT. ENDYEAR) GOTO 200
	IF ((YEAR .EQ. ENDYEAR) .AND. (JUL .GT. ENDJUL)) GOTO 200
c		we got one
	CALL QPL_INSERT (ARRAY,RATE,YEAR,JUL,BYR,BJL,DATAPOINT,
     2	HOUR,MINUTE)
	GOTO 155
c----------------------------------------------------------------------------
c		all done - either the end of the file or past the end times
c		write the last segment out
200	IF (WR_ARRAY(ARRAY) .GT. 1) THEN
		WRITE(UNIT=49+ARRAY,REC=WR_ARRAY(ARRAY)) C_ARRAY(ARRAY)
		END IF
	CALL TOP (ARRAY)
c		we now need to check for the hilo values.  this was not possible
c		before because we may have had many points put into a single
c		time slot.
	CALL ZERO_HILO(ARRAY)
	DO 175 K=1,LAST,ARRSIZ
		CALL DISK_ (ARRAY,.FALSE.)
		CALL ARR_END (K,LAST,LEFT)
	DO 174 I=1,LEFT
		CALL NU_HILO(DATA(I,ARRAY),ARRAY)
174		CONTINUE
175		CONTINUE
	CALL WR_LAST(ARRAY,.FALSE.)
	CALL TOP (ARRAY)
	CLOSE(2)
	RETURN(2)
250	CLOSE(2)
	RETURN
c----------------------------------------------------------------------------
c		error in reading the qplot file.  as some files may have
c		some headings or comments, we just note it and continue
c		as to why i have to use a read - if i don't it will hang
c		up and require a cold boot after about 16 times through.
c		talk to microsoft as its their compiler!
300	READ(UNIT=2,FMT='(A)',END=200)LINE
	GOTO 155
c----------------------------------------------------------------------------
c		nasty error or no qplot file. return to fill arrays with
c		normal direct access procedures
400	WRITE(*,*) ' ERROR IN QPLOT FILE SET-UP'
450	CLOSE(2)
	RETURN(1)
c---------------------------------------------------------------------------
c		rate not an integral divisor in 1440
460	WRITE(*,*)' RATE NOT AN INTEGRAL DIVISOR OF 1440 MINUTES/DAY'
	RETURN(1)
c--------------------------------------------------------------------------
c		no qplot file or at its end.  increment to next year or month
c		if its that sort of qplot file.
500	IF((YR_LOG) .OR. (MMM_LOG) .OR. (DD_LOG)) THEN
c			get the next month,day,year
		IF (DD_LOG) THEN
			FDAY=FDAY+1
		ELSE IF (MMM_LOG) THEN
			FMONTH=FMONTH+1
		ELSE IF (YR_LOG) THEN
			FYEAR=FYEAR+1
			END IF
		HOUR=0
		MINUTE=0
c			clean it up for 30 days in FEB stuff
		CALL CLNTIME(MINUTE,HOUR,FDAY,FMONTH,FYEAR)
c			see if we are past the end of the time 
c			period of interset
		IF (FYEAR .GT. ENDYEAR) GOTO 200
		IF (MMM_LOG) THEN
			IF ((FMONTH .GT. ENDMONTH) .AND. 
     2			(FYEAR .GE. ENDYEAR)) THEN
				GOTO 200
				END IF
			END IF
		IF (DD_LOG) THEN
			IF ((FMONTH .GE. ENDMONTH) .AND. 
     2			  (FYEAR .GE. ENDYEAR).AND.
     2			  (FDAY .GT. ENDDAY)) THEN
				GOTO 200
				END IF
			END IF
c			try to open it now
		GOTO 153
		END IF
c		only the one file and we are done with it
	GOTO 200
c---------------------------------------------------------------------------
	END
c----------------------------------------------------------------------------
