***************************************************************************
c		runmean   (NOT YET SET UP FOR PC-BOB)
c***************************************************************************
c	runmean computes a running mean of the data in one of the arrays.
c	the passed argument reel says the maximum number of points to
c	average together. runmean prompts for the minimum number of points
c	to average. this allows for averaging over missing data points
c	and can even fill in some of the missing points for a smoother
c	line fit. as with most simple averagiung routines, be aware that
c	a phase shift equal to half(?) the time span for avearging
c	can occur.
c--------------------------------------------------------------------------
	SUBROUTINE RUNMEAN(ARRAY,LSTPT,REEL)
c--------------------------------------------------------------------------
c-------- the data arrays and the passed arguments
$INCLUDE:'DATARRAY.INC'
	REAL*4 REEL
	INTEGER LSTPT,NUM, ARRAY
c-------- the buffer array for storing data (max. of 1440 data points
c-------- can be averaged)
	REAL*4 BUFFER(1440)
c------- the pointers and data holders
	INTEGER POINTER,NECESSARY,VALID,OFFSET
	REAL*4 TOTAL,TEMP1
c------- the file i/o for executable files
$INCLUDE:'EXEC.INC'
c-----------------------------------------------------------------------------
c
c			program begins
c-----------------------------------------------------------------------------
c------- convert the passed argument to an integer
	NUM=REEL
	IF (NUM .GT. 1440) THEN
		WRITE(*,*) ' MAXIMUM NUMBER OF POINT TO AVERAGE OF 1440 EXCE
     2EDED. TRY AGAIN'
		RETURN
		END IF
c------
100	FORMAT(' WHAT IS THE MINIMUM NUMBER OF VALID DATA POINTS NECESSARY
     2')
110	FORMAT(' TO COMPUTE THE MEAN ? ',$)
115	WRITE(*,100)
	WRITE(*,110)
	READ(UNITR,*,ERR=115) NECESSARY
	IF (SAVECOMM) THEN
		WRITE(10,*)NECESSARY
		END IF
c-----------------------------------------------------------------------------
c------ initialize some things
	VALID=0
	TOTAL=0
	ALLPOINTS=0
	POINTER=1
	DO 130 J=1,NUM
		BUFFER(J)=-998
130		CONTINUE
c------ and do it
	DO 200 J=1,LSTPT+NUM-2
c------	take out the last value
		TEMP1=BUFFER(POINTER)
		IF (TEMP1 .NE. -998) THEN
			TOTAL=TOTAL-TEMP1
			VALID=VALID-1
			END IF
c------ put in the new point
		TEMP1=DATA(J,ARRAY)
		BUFFER(POINTER)=TEMP1
		IF ((TEMP1 .NE. -998) .AND. (J .LE. LSTPT)) THEN
			TOTAL=TOTAL+TEMP1
			VALID=VALID+1
			END IF
c----- compute the phase shift. in the middle of the array the points are
c----- shifted backwards (num-1)/2 points. at the beginning and end though
c----- a sliding offset occurs because we don't have the full num points to
c----- average
		IF (J .LT. NUM) THEN
			OFFSET=J-(J-1)/2
		ELSE IF (J .LE. LSTPT) THEN
			OFFSET=J-(NUM-1)/2
		ELSE
			OFFSET=LSTPT-(NUM-J+LSTPT-1)/2
			END IF
c----- if we got enough compute the mean
		IF (VALID .GE. NECESSARY) THEN
			DATA(OFFSET,ARRAY)=TOTAL/VALID
		ELSE
			DATA(OFFSET,ARRAY)=-998
			END IF
c---- reset the pointer for the next round
		POINTER=(MOD(POINTER,NUM)+1)
200		CONTINUE
c--------------------------------------------------------------------
	RETURN
	END
c--------------------------------------------------------------------	        

