******************************************************************************
c			showdat
*****************************************************************************
c-------showdat dispalys the data of an array specified by its argument on 
c-------the terminal or writes it out to a file, again depending on the
c-------argument. because the points/per day may vary greatly, only the follow-
c-------ing data intervals are supported with a readable format as opposed to
c-------just a long list of numbers.
c
c points/day  data interval  time/line  points/line  time/screen  points/screen
c------------------------------------------------------------------------------
c   1440         1 min         5 min         5           1 hr         60
c    288         5 min        30 min         6           6 hr         72
c    260         6 min        30 min         5           6 hr         60
c    144        10 min         1 hr          6          12 hr         72
c     96        15 min         1 hr          4          12 hr         48
c     72        20 min         2 hr          6           1 day        72
c     48        30 min         2 hr          4           1 day        48
c     24         1 hr          6 hr          6           3 day        72
c     12         2 hr         12 hr          6           6 day        72
c      8         3 hr         12 hr          4           6 day        48
c      6         4 hr          1 day         6           12 day       72
c      4         6 hr          1 day         4           12 day       48
c      3         8 hr          2 day         6           24 day       72
c      2        12 hr          3 day         6           36 day       72
c      1         1 day         5 day         5           60 day       60
c-----------------------------------------------------------------------------
c------with that out of the way lets get started
	SUBROUTINE SHOWDAT( PRNT,*)
c-----------------------------------------------------------------------------
c----------------the command variables
$INCLUDE:'COMMAND.INC'
	CHARACTER*1 CHARA
c----------------the logical to determine if this to be displayed or written
	LOGICAL PRNT
c---------------the data array and the headers
$INCLUDE:'DATARRAY.INC'
$INCLUDE:'HEADER.INC'
$INCLUDE:'PLTHDR.INC'
	INTEGER ARRAY,DUM1
c--------------the time variables,the points variable and array pointer
	INTEGER BYR,BJL,BHR,BMIN,LJL,LHR,LMIN,SJL,SHR,SMIN,ARRPTR
	INTEGER SCRNPTS,LINEPTS,LSTPT,SEG_PTR
	INTEGER INTRVL(3,6)
c-------------the prompt variable, the output unit, and the format numbers
	CHARACTER*4 STOPP
	INTEGER UNT,HDRFRMT,LINFRMT
	CHARACTER*12 FILNME
	REAL*4 DOUT(6)
c---------	where the input comes or goes
$INCLUDE:'EXEC.INC'
******************************************************************************
*		program begins
******************************************************************************
c		get the rest of the command, the array, and the # of points
	CALL NOBLANX (COMM,PTR1,*400)
	CHARA=COMM(PTR1:PTR1)
	CALL GETPTR (CHARA,ARRAY,LSTPT,*410)
c		determine where the output is to go
	IF (PRNT) THEN
40		UNT=2
50		FORMAT(A44,$)
		WRITE(*,50) ' FULL NAME OF FILE (MAX. OF 12 CHARACTERS)'
60		FORMAT(A12)
		READ(UNITR,60,ERR=65) FILNME
		IF (SAVECOMM) THEN
			WRITE(10,60)FILNME(1:12)
			END IF
		IF (FILNME(1:5) .EQ. 'ABORT') GOTO 400
		OPEN(UNIT=2,FILE=FILNME,STATUS='UNKNOWN',ERR=65)
		GOTO 70
65		WRITE(*,*) ' ERROR IN FILENAME OR OPENING FILE, TRY AGAIN OR
     2 TYPE ABORT'
		GOTO 40
	ELSE 
		UNT=0
		END IF
c----------------------------------------------------------------------------
c		determine how many pts/line and pts/screen
70	RATE=HDR(3,ARRAY+1)
	IF (RATE .EQ. 0) GOTO 410
	IF ((RATE .EQ. 288).OR.(RATE .EQ. 144).OR.(RATE .EQ. 72).OR.
     2	(RATE .EQ. 24).OR.(RATE .EQ. 12).OR.(RATE .EQ. 6).OR.
     3	(RATE .EQ. 3).OR.(RATE .EQ. 2)) THEN
		LINEPTS=6
	ELSEIF ((RATE .EQ. 1440).OR.(RATE .EQ. 260).OR.(RATE .EQ. 1)) 
     2		THEN
		LINEPTS=5
	ELSE 
		LINEPTS=4
		END IF
	SCRNPTS=LINEPTS*12
c-----------------------------------------------------------------------------
c		get the total number of points
	LSTPT=HDR(2,ARRAY+1)*HDR(3,ARRAY+1)
c		get the start time and the intervals for the lines and screens
	BJL=HDR(1,ARRAY+1)
	BYR=HDR(4,ARRAY+1)
	BHR=0
	BMIN=0
	LHR=0
	SHR=0
c		we use the rate and the minutes in a day (1440) for the inrtvls
	LMIN=1440/RATE
	LMIN=LMIN*LINEPTS
c		the screen parameters are used in going back through the data
c		they get multiplied by two so that we dont get the same screen
c		each time as after one screen is displayed, the variables are
c		all set for the next
	SMIN=LMIN*12*2
c		time fix can put these numbers into real julian times as long
c		as we make sure the jl doesnt=0. we correct this after we come
c		back
	LJL=1
	SJL=1
	CALL TIMEFIX (BYR,LJL,LHR,LMIN)
	CALL TIMEFIX (BYR,SJL,SHR,SMIN)
	LJL=LJL-1
	SJL=SJL-1
c		get the time interval between the first point in a line and the
c		rest. jl must be adjusted as above
	DO 90 I=1,3
		DO 80 J=1,6
			INTRVL(I,J)=0
80			CONTINUE
90		CONTINUE
	DO 100 I=1,LINEPTS
		INTRVL(3,I)=(I-1)*1440/RATE
		INTRVL(1,I)=1
		CALL TIMEFIX (BYR,INTRVL(1,I),INTRVL(2,I),INTRVL(3,I))
		INTRVL(1,I)=INTRVL(1,I)-1
100		CONTINUE
c------------------------------------------------------------------------------
c		and we are ready to start writing
c		first print the header (we have to play a quick game with array)
105	DUM1=ARRAY+1
	CALL SHOHDR (DUM1,UNT,*110)
110	ARRPTR=1
c		pointers for the disk/array stuff.
	SEG_PTR=1
	CALL DISK_(ARRAY,.FALSE.)
c	the following are the 3 formats for displaying the following:
c			the full time of what is to follow
120	FORMAT(' FOLLOWING DATA STARTS AT ',I3.3,':',I2.2,':',I2.2,
     2	'  19',I2.2)
c			the header for the data pts
130	FORMAT('   ',A3,7X,6('+',I3.3,':',I2.2,':',I2.2,1X))
c			the format for the data
140	FORMAT(1X,I3.3,':',I2.2,':',I2.2,2X,6(1X,F10.2))
c-----------------------------------------------------------------------------
c		so lets start. the arrptr is set to one and we enter the loop
c----------------------------------------------------------------------------
c		350 is the stop spot
150	IF (ARRPTR .GT. LSTPT) GOTO 350
	WRITE(UNIT=UNT,FMT=*)' -------------------------------------------
     2----------------------------------'
	WRITE(UNIT=UNT,FMT=120) BJL,BHR,BMIN,BYR
	WRITE(UNIT=UNT,FMT=130) TME,(INTRVL(1,P),INTRVL(2,P),
     2		INTRVL(3,P),P=1,LINEPTS)
	WRITE(UNIT=UNT,FMT=*)' -------------------------------------------
     2----------------------------------'
c		we always put out 12 lines of data
	DO 300 I=1,12
c		since we might overrun the end of the array we have to buffer
c		the output points
		DO 200 J=1,LINEPTS
			IF (ARRPTR .GT. LSTPT) THEN
				DOUT(J)=-998.0
			ELSE
				DOUT(J)=DATA(SEG_PTR,ARRAY)
				END IF
			ARRPTR=ARRPTR+1
			SEG_PTR=SEG_PTR+1
			IF (SEG_PTR.GT.ARRSIZ) THEN
				CALL DISK_(ARRAY,.FALSE.)
				SEG_PTR=1
				END IF
200		CONTINUE
c		and write it out
		WRITE(UNIT=UNT,FMT=140)BJL,BHR,BMIN,(DOUT(T),T=1,LINEPTS)
c			increment the time for each line
		BMIN=LMIN+BMIN
		BHR=BHR+LHR
		BJL=BJL+LJL
		CALL TIMEFIX(BYR,BJL,BHR,BMIN)
300		CONTINUE
c---------------------------------------------------------------------------
c		see if we want to continue, stop or go backwards. but only if
c		we are displaying the data on the terminal
	IF (.NOT. PRNT) THEN
310	  FORMAT(' TYPE STOP TO STOP, - TO GO BACK, OR <CR> TO CONTINUE '
     2		,$)
		WRITE(*,310)
315		FORMAT(A4)
		READ(UNITR,315) STOPP
		IF (SAVECOMM) THEN
			WRITE(10,315)STOPP
			END IF
		IF (STOPP .EQ. 'STOP') GOTO 350
		IF (STOPP .EQ. '-') THEN
c			if its negative we have to move back 2 screens from 
c			where we are now or else we would see the current 
c			display again
			ARRPTR=ARRPTR-2*SCRNPTS
			SEG_PTR=SEG_PTR-2*SCRNPTS
c			see if we are back to the beginning, if so go to there
			IF (ARRPTR .LE. 1)  THEN
				BMIN=0
				BHR=0
				BJL=HDR(1,ARRAY+1)
				BYR=HDR(4,ARRAY+1)
				ARRPTR=1
				SEG_PTR=1
				CALL TOP(ARRAY)
				GOTO 105
				END IF
c		clean up where we are in the disk array stuff if we didn't go
c		all the way back
			IF (SEG_PTR .LT.1) THEN
				SEG_PTR=1440+SEG_PTR
				WR_ARRAY(ARRAY)=WR_ARRAY(ARRAY)-1
				READ(UNIT=49+ARRAY,REC=WR_ARRAY(ARRAY))
     2				C_ARRAY(ARRAY)
				RD_ARRAY(ARRAY)=RD_ARRAY(ARRAY)-1
				END IF
c			correct the time for the past
			BMIN=BMIN-SMIN
			BHR=BHR-SHR
			BJL=BJL-SJL
			CALL TIMEFIX (BYR,BJL,BHR,BMIN)
			END IF
		END IF
c-----------------------------------------------------------------------------
c		continue on with the next screen
	GOTO 150
c-----------------------------------------------------------------------------
c		the closing up
350	CALL TOP(ARRAY)
	IF (PRNT) THEN
		CLOSE(UNT)
360		FORMAT (1X,'DATA WRITTEN TO FILE ',A12)
		WRITE (*,360) FILNME
		END IF
	RETURN(1)
400	WRITE(*,*)' NEEDS AN ARRAY - SHOW DATA ABORTED'
	RETURN(1)
410	WRITE(*,*) ' NO DATA IN FILE, SHOW DATA ABORTED'
	RETURN(1)
	END
*******************************************************************************

