******************************************************************************
*		tonow
******************************************************************************
c	tonow looks at the julian time in the working header and computes
c	the days to the present time. this is entered into the working
c	header as days, so that it will now be a able to access all the data
c	from a specific time to the present. note: this assumes the vax clock
c	is correct
c	if what=1 the ending date is from the computer clock
c	if what=2 the ending date is from the command e_date
c----------------------------------------------------------------------------
	SUBROUTINE TONOW (WHAT,*)
c----------------------------------------------------------------------------
c--------the characters , mainly for time
	INTEGER JUL,YR,DAYS
	CHARACTER*8 CURTME
	CHARACTER*3 CMON
	INTEGER WHAT,CURJUL,CURYR,CURMON,CURDAY
	INTEGER*2 IBMMON,IBMYR,IBMDAY
c--------the header , and command line
$INCLUDE:'HEADER.INC'
$INCLUDE:'COMMAND.INC'
c-----------------------------------------------------------------------------
c---------	get the beginning time from the header
	JUL=HDR(1,1)
	YR=HDR(4,1)
	IF ((JUL .EQ. 0) .OR. (YR .EQ.0)) GOTO 400
c-----------------------------------------------------------------------------
	IF (WHAT .EQ. 1) THEN
c--------	get the current time from the vax
		CALL GETDAT (IBMYR,IBMMON,IBMDAY)
		CURYR=MOD(IBMYR,100)
		CURMON=IBMMON
		CURDAY=IBMDAY
	ELSE IF (WHAT .EQ. 2) THEN
c		get it from the command line
		CALL NOBLANX(COMM,PTR1,*201)
		CALL IGETNUM(COMM)
		IF ((NUM .LT. 1).OR.(NUM .GT. 31)) CALL ERARG(*201)
		CURDAY=NUM
		PTR1=PTR1+1
		CMON=COMM(PTR1:PTR1+2)
		CALL MON_2_INT(CMON,CURMON,.FALSE.)
		IF (CURMON .EQ. 0) CALL ERARG(*201)
		PTR1=PTR1+4
		CALL IGETNUM(COMM)
		CURYR=MOD(NUM,100)
		END IF
c--------	and convert it to julian time
	CALL GETJUL (CURJUL,CURYR,CURMON,CURDAY)
c------------------------------------------------------------------------------
c-------- and now figure out the days
	DAYS=0
100	IF (YR .NE. CURYR) THEN
		JUL=JUL
		DAYS=(DAYS-JUL)+366

		IF (MOD(YR,4) .EQ. 0) DAYS=DAYS+1
		JUL=1
		YR=YR+1
c----------we insert an escape in case we get something very mixed up
		IF (DAYS .GT. 36600) GOTO 400
		GOTO 100
		END IF
c------------------------------------------------------------------------------
c-------	once we are in the same year, it is easy
	DAYS=DAYS+(CURJUL-JUL)+1
c-------- 	put it in the header and be gone
	HDR(2,1)=DAYS
201	RETURN(1)
400	WRITE (6,*) ' ERROR IN HEADER OR COMPUTER CLOCK'
	RETURN(1)
	END
c-----------------------------------------------------------------------------