**************************** tzone str,i,i,i **********************************
c
c		tzone takes the julian day and yr in gmt and converts it to
c		the equivalent time in another time zone (pst or pdt)
c
	SUBROUTINE TZONE(ZONE,JUL,YR,HR)
c		the variables
	CHARACTER*3 ZONE
	INTEGER JUL,YR,HR
c----------------------------------------------------------------------------
	HR=0
c		this is a little messy. some places use GMT others use local
c		(especially if there is no daylight savings).  At CVO, data
c		from BOB files is GMT, QPLOT files in local.  For the 
c		distribution BOB, this is too specialized.  Therefore, the
c		assumption will be that the time will be the same throughout
c		the system, including the computer's clock.  LOCal time will
c		be the default.  If ZONE equals LOC then all plots will have
c		the start time state "LOCAL", and nothing need be changed.
c
c		If you are using GMT as the base time, you'll need to change
c		the label on the plot to GMT, but the nothing else will
c		change.  The TZONE command simply sets the start time to state
c		"GMT" instead of "LOCAL".
c
c		But if you are using GMT and want to convert the time axis 
c		on the plot to local time, say PST, this subroutine will
c		make the changes.
c
c		You CANNOT convert from a local time to PST using this
c		routine.  It will execute, but it will not make the
c		correct offset.

c		if gmt or loc nothing needs to be changed
	IF (ZONE .EQ. 'GMT') RETURN
	IF (ZONE .EQ. 'LOC') RETURN
c		the assumption is that the time is in GMT and you want
c		to convert to a local time.  

c		and set the hour to what it is at midnight GMT
	IF (ZONE .EQ. 'HST') THEN
		HR=14
	ELSE IF (ZONE .EQ. 'AST') THEN
		HR=15
	ELSE IF (ZONE .EQ. 'ADT') THEN
		HR=16
	ELSE IF (ZONE .EQ. 'PST') THEN
		HR=16
	ELSE IF (ZONE .EQ. 'PDT') THEN
		HR=17
	ELSE IF (ZONE .EQ. 'MST') THEN
		HR=17
	ELSE IF (ZONE .EQ. 'MDT') THEN
		HR=18
	ELSE IF (ZONE .EQ. 'CST') THEN
		HR=18
	ELSE IF (ZONE .EQ. 'CDT') THEN
		HR=19
	ELSE IF (ZONE .EQ. 'EST') THEN
		HR=19
	ELSE IF (ZONE .EQ. 'EDT') THEN
		HR=20
	ELSE
c		not a known time zone. treat it like a LOC
		RETURN
		END IF
c			hour is now set
c			day starts in Greenwich so first subtract a day
	JUL=JUL-1
	IF (JUL .LE. 0) THEN
		YR=YR-1
		IF (MOD(YR,4) .EQ. 0) THEN
			JUL=366
		ELSE
			JUL=365
			END IF
		END IF
	RETURN
	END
c----------------------------------------------------------------------------- 