c
c                 xaxis
c
c	     xaxis is a subroutine to draw the tic marks on the time
c	axis for the plots generated by bob.for.
c
c----------------------------------------------------------------------------
	SUBROUTINE XAXIS(BOTLAB,Y,GRAPHLFT,GRAPHRT,YR,JUL,ZONE,
     2	HR,DAY,MON,DAYS,TITLELAB,TITLE,TOP)
c******************************************************************************
c
c	      the logicals that indicate which and if tics get labeled
c
	LOGICAL HR4LAB,DAYLAB,DAY5LAB,DAY10LAB,MON1LAB
	LOGICAL MON3LAB,YRLAB,TIKLABEL,BOTLAB,TITLELAB
c			is the top axis or bottom
	LOGICAL TOP
c------------------------------------------------------------------------------
c		the month array, the title, and the label for the tics
c
	CHARACTER*48 XMON
	CHARACTER*50 TITLE
	CHARACTER*47 JULABEL
	CHARACTER*3 ZONE
	CHARACTER*4 LABEL
c------------------------------------------------------------------------------
c
c		the time variables, and hours between tics
c
	INTEGER HR1,MIN1,DAY1,MON1,YR1,JUL1,DAYS,TIC
	INTEGER HR,MIN,DAY,MON,YR,JUL
c------------------------------------------------------------------------------
c		the hours to the first tic mark
c
	REAL*4  HROFF
c------------------------------------------------------------------------------
c		the position and one days length on the axis
c
	REAL*4 X,Y,DAYLEN,GRAPHLFT,GRAPHRT
c******************************************************************************
c		let the program begin
c******************************************************************************
c
c
	YR1=YR
	MON1=MON
	DAY1=DAY
	HR1=HR
	JUL1=JUL
	XMON='JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC '
c
	MIN1=0.0
c
c		calculate tic spacing in hours
c
	IF (DAYS .LT. 11) THEN
		TIC=4
	ELSE IF (DAYS .LT. 121) THEN
		TIC=24
	ELSE IF (DAYS .LT. 181) THEN
		TIC=120
	ELSE IF (DAYS .LT. 367) THEN
		TIC=240

	ELSE IF (DAYS .LT. 7306) THEN
		TIC=696
	ELSE
		TIC=365*24
	END IF
c------------------------------------------------------------------------------
c
c		since months dont have the same # of days get the axis len/day
	IF (DAYS .LT. 1) RETURN
	DAYLEN=(GRAPHRT-GRAPHLFT)/DAYS
c------------------------------------------------------------------------------
c
c		decide which tics get labeled
c
	HR4LAB= .TRUE.
	DAYLAB= .TRUE.
	DAY5LAB= .TRUE.
	DAY10LAB= .TRUE.
	MON1LAB= .TRUE.
	MON3LAB=.TRUE.
	YRLAB= .TRUE.
	IF (DAYS .GT. 4)  HR4LAB=.FALSE.
	IF (DAYS .GT. 20) DAYLAB=.FALSE.
	IF (DAYS .GT. 75) DAY5LAB=.FALSE.
	IF (DAYS .GT. 150) DAY10LAB=.FALSE.
	IF (DAYS .GT. 400) MON1LAB=.FALSE.
	IF (DAYS .GT.1200) MON3LAB=.FALSE.
	IF (DAYS .GT. 7306) YRLAB=.FALSE.
c		month and year are always labeled
c------------------------------------------------------------------------------
c		find (in hours) the offset to the first tic mark
c
c		hrs will be kept in hroff
c
	HROFF=0.0
c------------------------------------------------------------------------------
c		try to hit a 4 hr mark first
c
50	IF (.NOT.( (MIN1 .EQ. 00) .AND. (MOD(HR1,4) .EQ. 0))) THEN
		HROFF=HROFF+1.0/60.0
		MIN1=MIN1+1
		IF (MIN1 .GT. 59) CALL CLNTIME(MIN1,HR1,DAY1,MON1,YR1)
		GOTO 50
		END IF
c------------------------------------------------------------------------------
c		if 4 hour is a tic mark we are done, else go for days
c
	IF (TIC .EQ. 4) GOTO 80
55	IF (HR1 .NE. 00) THEN
		HROFF=HROFF+1.0
		HR1=HR1+1
		IF (HR1 .GT. 23) CALL CLNTIME(MIN1,HR1,DAY1,MON1,YR1)
		GOTO 55
		END IF
c-----------------------------------------------------------------------------
c		if day is a tic mark we are done, else go for 5 days
c
	IF (TIC .EQ. 24) GOTO 80
60	IF (.NOT.( (DAY1 .EQ. 01) .OR. ((MOD(DAY1,5) .EQ. 0) .AND.
     2	 (DAY1.LT.28)))) THEN
		HROFF=HROFF+24.0
		DAY1=DAY1+1
		IF (DAY1 .GT. 28) CALL CLNTIME(MIN1,HR1,DAY1,MON1,YR1)
		GOTO 60
		END IF
c-----------------------------------------------------------------------------
c		if 5 days is a tic mark we are done, else go for 10 days
c
	IF (TIC .EQ. 120) GOTO 80
65	IF (.NOT.((DAY1 .EQ. 01) .OR. (DAY1 .EQ. 10) .OR. 
     2	(DAY1.EQ.20))) THEN
		HROFF=HROFF+24.0
		DAY1=DAY1+1
		IF (DAY1 .GT. 28) CALL CLNTIME(MIN1,HR1,DAY1,MON1,YR1)
		GOTO 65
		END IF
c------------------------------------------------------------------------------
c		if 10 days is a tic mark we are done, else go for month
c
	IF (TIC .EQ. 240) GOTO 80
70	IF (DAY1 .NE. 01) THEN
		HROFF=HROFF+24.0
		DAY1=DAY1+1
		IF (DAY1 .GT. 28) CALL CLNTIME(MIN1,HR1,DAY1,MON1,YR1)
		GOTO 70
		END IF
c-----------------------------------------------------------------------------
c		if month is a tic mark we are done,else try year
	IF (TIC .EQ. 696) GOTO 80
75	IF ((DAY1 .NE. 01) .OR. (MON1 .NE.01)) THEN
		HROFF=HROFF+24.0
		DAY1=DAY1+1
		IF (DAY1 .GT. 28) CALL CLNTIME(MIN1,HR1,DAY1,MON1,YR1)
		GOTO 75
		END IF
c------------------------------------------------------------------------------
c		hroff now has our offset in hours and day1,etc has the time
c		of the first tic mark
c
c******************************************************************************
c		so lets start drawing something
c******************************************************************************
c
c
80	CALL PLOT(GRAPHLFT,Y,3)
	CALL PLOT(GRAPHRT,Y,2)
c------------------------------------------------------------------------------
c		go to where the first tic mark is to be and start the tic loop
c
	X=GRAPHLFT+DAYLEN*HROFF/24.0
350	IF (X .LE. GRAPHRT) THEN
	CALL PLOT (X,Y,3)
c		draw the small tic
	IF (TOP) THEN
		CALL PLOT (X,Y-.065,2)
	ELSE
		CALL PLOT (X,Y+.065,2)
		END IF
c------------------------------------------------------------------------------
c		see if it should be a labeled and longer tic
c
	TIKLABEL=.FALSE.
	IF ( (MON1 .EQ. 1) .AND. (DAY1 .EQ. 1) .AND. (HR1 .EQ. 0).AND.
     2		(MOD(YR1,2) .EQ. 0)) THEN
		TIKLABEL =.TRUE.
		CALL TICLAB(LABEL,YR1)
	ELSE IF ((MON1 .EQ. 1) .AND. (DAY1 .EQ. 1).AND.(HR1 .EQ. 0).AND.
     2		(YRLAB)) THEN
		TIKLABEL =.TRUE.
		CALL TICLAB(LABEL,YR1)
	ELSE IF ( (DAY1 .EQ. 1) .AND. (HR1 .EQ. 0) .AND. (MON3LAB)
     2	.AND. (MOD((MON1-1),3) .EQ. 0)) THEN
		TIKLABEL=.TRUE.
		LABEL=XMON(MON1*4-3:MON1*4)
	ELSE IF ( (DAY1 .EQ. 1) .AND. (HR1 .EQ. 0) .AND. (MON1LAB)) THEN
		TIKLABEL=.TRUE.
		LABEL=XMON(MON1*4-3:MON1*4)
	ELSE IF ( (DAY10LAB) .AND. ((DAY1 .EQ. 10) .OR. (DAY1 .EQ. 20))
     2	.AND. (HR1 .EQ. 0)) THEN
		TIKLABEL=.TRUE.
		CALL TICLAB(LABEL,DAY1)
	ELSE IF ((DAY5LAB) .AND. (MOD(DAY1,5) .EQ. 0).AND. (DAY1 .LT. 28)
     2	.AND. (HR1 .EQ. 0)) THEN
		TIKLABEL=.TRUE.
		CALL TICLAB(LABEL,DAY1)
	ELSE IF ((DAYLAB) .AND. (HR1 .EQ. 0)) THEN
		TIKLABEL=.TRUE.
		CALL TICLAB (LABEL,DAY1)
	ELSE IF ((HR4LAB) .AND. (MOD(HR1,4) .EQ. 0)) THEN
		CALL TICLAB(LABEL,HR1)
		IF (BOTLAB) CALL SYMBOL (X,Y-0.2,0.09,LABEL,0.0,3)
		END IF
	IF (TIKLABEL) THEN
		IF (TOP) THEN
			CALL PLOT (X,Y-0.125,2)
		ELSE
			CALL PLOT(X,Y+0.125,2)
			END IF
		END IF		
	IF ((TIKLABEL) .AND. (BOTLAB)) THEN
		CALL SYMBOL(X,Y-0.22,0.15,LABEL,0.0,3)
		END IF
c----------------------------------------------------------------------------
c		increment everything up to the next tic mark
c
	X=X+DAYLEN*TIC/24
	HR1=HR1+TIC
	CALL CLNTIME(MIN1,HR1,DAY1,MON1,YR1)
c		if we are doing yearly tics we have to worry about the leap year
c		check mon1 because the yr1 will increment into the leap year
c		when we just come to it
	IF ((TIC .EQ. (365*24)) .AND. (MOD(YR1,4) .EQ. 0) .AND.
     2	(MON1 .GT. 1)) THEN
		X=X+DAYLEN
		DAY1=1
		MON1=1
		YR1=YR1+1
		GOTO 500
		END IF
	IF (TIC .EQ. (365*24)) GOTO 500
c		we have to take care of the fact that there are 4 days between
c		the 1st and 5th or 9 days between the 1st 10th of a month when
c		doing tic marks of 10 or 5 days
	IF (((DAY1 .EQ. 6) .AND. (TIC .EQ. 120)) .OR.
     2	((DAY1 .EQ. 11) .AND. (TIC .EQ. 240))) THEN
		DAY1=DAY1-1
		X=X-DAYLEN
		END IF
c		if we are ticing days and hours go to the end while
c		or if we are before the possible end of the month
c		if the number is below 5 then it might be a feb. 30 also
	IF ((TIC .LT. 120) .OR. ((DAY1 .GT. 4) .AND. 
     2	(DAY1.LT.26))) GOTO 500
c		deal with feb. first-remember we would be in the next month
	IF ((MON1 .EQ. 3) .AND. (DAY1 .LT. 3)) THEN
		IF (DAY1 .EQ. 2) X=X-DAYLEN
c		this will be bumped back up farther down
		MON1=MON1-1
c		the rest of the months
	ELSE IF ((MON1.EQ.4) .OR. (MON1.EQ.6) .OR. (MON1.EQ.9) .OR.
     2	(MON1.EQ.11)) THEN
		X=X+DAYLEN
	ELSE
		X=X+2.0*DAYLEN
		END IF
	DAY1=1
	MON1=MON1+1
	IF (MON1 .EQ. 13) THEN
		MON1=1
		YR1=YR1+1
		END IF
500	GOTO 350
	END IF
c-----------------------------------------------------------------------------
c		label?
501	IF (BOTLAB) THEN
		JULABEL='START DAY IS MON XX 19XX local - JULIAN DAY XXX'
		JULABEL(14:16)=XMON(MON*4-3:MON*4-1)
		IF (ZONE.EQ.'LOC') THEN
			JULABEL(26:30)='LOCAL'
		ELSE
			JULABEL(26:28)=ZONE
			JULABEL(29:30)='  '
			END IF
		JULABEL(18:18)=CHAR(INT(DAY/10)+48)
		JULABEL(19:19)=CHAR(MOD(DAY,10)+48)
		YR1=MOD(YR,100)
		JULABEL(23:23)=CHAR(INT(YR1/10)+48)
		JULABEL(24:24)=CHAR(MOD(YR1,10)+48)
		JULABEL(45:45)=CHAR(INT(JUL1/100)+48)
		JULABEL(46:46)=CHAR(INT(MOD(JUL1,100)/10)+48)
		JULABEL(47:47)=CHAR(MOD(JUL1,10)+48)
		CALL SYMBOL(GRAPHLFT+0.75,Y-0.45,0.15,JULABEL,0.0,47)
		END IF
c------------------------------------------------------------------------------
c		title?
	IF (TITLELAB) THEN
		CALL PLOT(GRAPHLFT+0.4,Y-0.35,3)
		CALL SYMBOL(GRAPHLFT+0.4,Y-0.35,0.15,TITLE,0.0,50)
		END IF
	CALL PLOT(0.0,4.95,3)
	RETURN
	END

