c******************************************************************************
c			yaxis
c******************************************************************************
c
c		yaxis draws the scale axis and figures the labeling
c		for the axis.
c******************************************************************************
	SUBROUTINE YAXIS(LABEL,X,GRAPHTOP,GRAPHBOT,HI,LO,GRAPHS,YLABEL,
     2 RIGHT)
c		declare the variables
c******************************************************************************
c		the label of the axis
c
	CHARACTER*15 YLABEL
c-----------------------------------------------------------------------------
c		real values for high and low values their diff. and a spare
c		and the real value between each tic mark
c
	REAL*4 SPOT,HI,LO,SPARE,DIF,TICVAL
	CHARACTER*10 REALSTR
c-----------------------------------------------------------------------------
c		the stuf to figure how many decimal places in the scale
	INTEGER DECPLACES,DEC2PLACES,TOT_LEN
	REAL*4 DEC_SPOT
	CHARACTER*5 FOUT
c------------------------------------------------------------------------------
c		x and y position var and length between tics
c
	REAL*4 X,Y,TICLEN
c------------------------------------------------------------------------------
c		whether we wwant 1,2,3 graphs on the screen and which one this
c		is, and the limits on the graph,and how many tic marks
	INTEGER GRAPHS,POSIT,TICS
	REAL*4 YTOP,YBOT,TICSR
c		left or right axis
	LOGICAL RIGHT
c-----------------------------------------------------------------------------
c		the top and bottom limits of the graph
	REAL*4 GRAPHTOP,GRAPHBOT
c-----------------------------------------------------------------------------
c		if we are to label this axis
	LOGICAL LABEL
c-----------------------------------------------------------------------------
c*****************************************************************************
c		program begins
c****************************************************************************
c
c		find our tic mark spacing in graph units(ticlen) and
c		real units (ticval)
c
	DIF=HI-LO
c		we will have 50 tics for 1 plot, 25 for 2, and 25 for 3 plots
	IF (GRAPHS . EQ. 1) THEN
		TICS=50
	ELSE IF (GRAPHS .EQ. 2) THEN
		TICS=25
	ELSE
		TICS=25
		END IF
	TICLEN=(GRAPHTOP-GRAPHBOT)/TICS
c		how many decimal places - first compute it for the maximum
c		precision of a real*4 number (7 decimal spots)
	IF (ABS(HI) .GT. ABS(LO)) THEN
		SPARE=(ALOG10(ABS(HI)))
	ELSE
		SPARE=(ALOG10(ABS(LO)))
		END IF
	DECPLACES=7-SPARE
	IF (SPARE .LE. 0) DECPLACES=DECPLACES+1
	IF (DECPLACES .LT. -1) DECPLACES=-1
c		now compute the number of decimal places to just barely handle
c		that needed for the difference
	SPARE=(ALOG10(DIF))
C		limit of 6 decimal places
	DEC2PLACES=6-SPARE
c	IF (SPARE .LE. 0) DEC2PLACES=DEC2PLACES+1
	IF (DEC2PLACES .LT. -1) DEC2PLACES=-1
c		detremine which one we use
	IF (DEC2PLACES .LT. DECPLACES) DECPLACES=DEC2PLACES
	DECPLACES=DECPLACES-1
	IF (DECPLACES .GT. 1) DECPLACES=DECPLACES-1
c		use it to determine the format for the output
	IF (DECPLACES .LE. 0) THEN
		FOUT='+F7.0'
		DECPLACES=0
		END IF
	IF (DECPLACES .EQ. 1) FOUT='+F7.1'
	IF (DECPLACES .EQ. 2) FOUT='+F7.2'
	IF (DECPLACES .EQ. 3) FOUT='+F7.3'
	IF (DECPLACES .EQ. 4) FOUT='+F7.4'
	IF (DECPLACES .EQ. 5) FOUT='+F7.5'
	IF (DECPLACES .GE. 6) THEN
		FOUT='+F7.6'
		DECPLACES=6
		END IF
c		and calculate the spot for the decimal point
	DEC_SPOT=X-(DECPLACES+1)*.148	
c----------------------------------------------------------------------------
c		start drawing the pictures
c
c		draw the axis
	CALL PLOT(X,GRAPHTOP,3)
	CALL PLOT(X,GRAPHBOT,2)
c---------------------------------------------------------------------------
c		draw the tics, 5 unlabeled, then a label, then 
c		every 5th one labeled
	Y=GRAPHBOT
	DO 100 I=0,TICS-1
		IF (RIGHT) THEN
			CALL PLOT(X-.0625,Y,2)
		ELSE
			CALL PLOT(X+.0625,Y,2)
			END IF
		IF ((MOD(I,5) .EQ. 0) .AND. (I .NE. 0)) THEN
			TICSR=TICS
			SPARE=I
			SPARE=LO+(DIF*SPARE/TICSR)
			IF (RIGHT) THEN	
				CALL PLOT(X-0.125,Y,2)
			ELSE
				CALL PLOT(X+0.125,Y,2)
				END IF
			IF (LABEL) THEN
			    CALL YNUMBER(SPARE,DEC_SPOT,Y,FOUT,
     2				DECPLACES)
			    END IF
			END IF
		Y=Y+TICLEN
		CALL PLOT (X,Y,3)
100		CONTINUE
c------------------------------------------------------------------------------
c		label the axis?
	IF ((LABEL) .OR. (.NOT.(RIGHT))) THEN
		CALL SYMBOL (0.2,(GRAPHBOT+GRAPHTOP)/2.0,
     2		0.15,YLABEL,90.0,-15)
		END IF
c-----------------------------------------------------------------------------
c		close up shop
c
	CALL PLOT(4.95,0.0,3)
	RETURN
	END
c------------------------------------------------------------------------------
